-*- coding: utf-8 -*-

commit 06a7b3c14453b35ff530b3a06c134193dc25207e
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-04-18 01:19:05 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-18 01:19:05 +0900

    Only test on known good platforms. (#13123)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit c4ae6cb5005cfa53be0af466a5619e7455c15744
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-04-17 22:21:51 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-17 22:21:51 +0900

    Prefer `th->ec` for stack base/size. (#13101)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 6556a7be2614d1c808ba7bd11e8b6158c99bc5f7
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-04-17 19:01:08 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-04-17 19:59:19 +0900

    Temporarily stop the trailing-space check in CI

    I will restore the check after the preview release

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13122

commit 25efd09c71fc53acf1c5ce7f994b1bb78396b9f9
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-04-17 17:10:16 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-04-17 19:59:19 +0900

    sample/trick2025/: adds the top-five entries of TRICK 2025

    See https://github.com/tric/trick2025 for TRICK 2025.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13122

commit 7e2ba5a91bcdc31e14502f797a6184e3f4d41747
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-17 07:19:07 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-17 08:08:37 +0900

    Don't use admin grant

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13121

commit 9b5ae69aac7246199c7cb8e32f7f0490fa519751
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-17 07:18:15 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-17 08:08:37 +0900

    Use uutils-coreutils

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13121

commit b4c29b7af648051430de5439740b6b08756d1d83
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-17 06:27:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-17 08:08:37 +0900

    Use coreutils instead of msys2 because msys2 is not provided windows-11-arm

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13121

commit 0a8a641d0a1917285cbfeca0dc47f7bd56c1f093
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-04-16 23:51:21 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-17 00:16:50 +0900

    [ruby/openssl] ssl: fix SSLSocket#syswrite with String-convertible objects

    Correctly pass the new object assigned by StringValue() to
    ossl_ssl_write_internal_safe().

    This is a follow-up to commit https://github.com/ruby/openssl/commit/0d8c17aa855d (Reduce
    OpenSSL::Buffering#do_write overhead, 2024-12-21).

    https://github.com/ruby/openssl/commit/3ff096196a

commit bbf873521a01c1c44297b9dd52cf4e309ae5b496
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2025-04-16 16:54:33 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2025-04-16 16:55:38 +0900

    Add description about edge cases of Enumerable#size

    [Bug #21152]

commit 8d21f666b8098545a366c46f1990edf2a9f4ffcb
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-04-16 16:50:37 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-16 16:50:37 +0900

    Introduce `enum rb_io_mode`. (#7894)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 51952929e1ddd01a17f9e47899ec4de35be002c6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-16 10:59:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-16 14:10:36 +0900

    [rubygems/rubygems] Fixed rubocop issue: Layout/SpaceInsideBlockBraces

    https://github.com/rubygems/rubygems/commit/77a52b011a

commit a4eb81a08334cbe2963e535f9cbfd0aea96c3144
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-16 10:39:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-16 11:40:11 +0900

    Revert advanced-security/filter-sarif update for v1.0.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13119

commit 02152501a41cd645267ffb8c2ee7aeb843a0fec8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-16 10:23:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-16 11:40:11 +0900

    Bump up to msys2/setup-msys2 to v2.27.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13119

commit 49c29cff479546df7e267d97ceb1f08a4d537a8e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-16 10:22:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-16 11:40:11 +0900

    Bump up to the latest versions of actions

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13119

commit 2cf95e2e0428a5cc07734789bbf618c014ad5c2d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-16 08:29:23 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-16 08:29:23 +0900

    Run the proper version of `rake`

commit 28491e53cda02c9b7372c01b88bf55dad50a53bf
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-04-15 20:15:26 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-15 20:15:35 +0900

    [ruby/stringio] Support for `rb_io_mode_t`
    (https://github.com/ruby/stringio/pull/129)

    Companion PR to <https://github.com/ruby/ruby/pull/7894>.

    https://github.com/ruby/stringio/commit/2d3988e12f

commit 77a52787a6321ee8964c1a6ccc5547abc4a08caf
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-15 13:43:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:48:22 +0900

    [ruby/json] Cleanup Kernel#JSON

    https://github.com/ruby/json/commit/573ebdca89

commit 26a9ccbf83957877355ef5eb3993dc28e07e4278
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-15 13:43:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:48:22 +0900

    [ruby/json] Deprecate Kernel#j and Kernel#jj

    https://github.com/ruby/json/commit/27155b6500

commit 1afc5399004ac5f27133469873571e7ff0ab16ab
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-15 13:35:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:48:21 +0900

    [ruby/json] Get rid of JSONError.wrap

    https://github.com/ruby/json/commit/3e7e661ef5

commit 62b7ae955a1fba88a4f70e270b1e118cc6c0d778
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-15 13:34:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:48:20 +0900

    [ruby/json] Don't create custom NaN and Infinity objects.

    https://github.com/ruby/json/commit/ff8e18392d

commit b8b4c15695ac4053b9d6c203e3948ea545be726b
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-13 04:06:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:47:22 +0900

    [rubygems/rubygems] Let `bundle lock --normalize-platforms` remove invalid platforms

    https://github.com/rubygems/rubygems/commit/c39d2f84fd

commit 1929e73a36958aee963d4e843716a3927d641d69
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-13 02:45:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:47:21 +0900

    [rubygems/rubygems] Raise an error if `bundle lock` target platform is incompatible

    https://github.com/rubygems/rubygems/commit/282e4a8593

commit 1b18810ed92191f53069f5ef285084d37cb26aed
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-13 02:43:52 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:47:21 +0900

    [rubygems/rubygems] Rename `resolution_packages` to `resolution_base`

    It handles resolution packages but also other stuff.

    https://github.com/rubygems/rubygems/commit/4baec92c20

commit c910e85b022bca1518dc720af968fbaf58fa453e
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-13 01:04:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:47:19 +0900

    [rubygems/rubygems] Extract some logic to a method and expand comment

    https://github.com/rubygems/rubygems/commit/ed31e888fd

commit 0ad7cf17a00d7f183f4fb41a9c4b595ea8bb99cd
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-13 03:00:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:47:19 +0900

    [rubygems/rubygems] Clarify comment

    https://github.com/rubygems/rubygems/commit/42534e746b

commit 806fbb1e477c4e70f3239a117a31ccef13f7aa2d
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-13 01:02:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:47:18 +0900

    [rubygems/rubygems] Comparing platforms is only needed for dependency validation

    If we materialized to a different platform, then the dependencies may
    actually be different so the validation does not really make sense.

    https://github.com/rubygems/rubygems/commit/68fad98e6f

commit 3cb573ee55f3d3af03f3a232ba442bd949277f17
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-12 23:01:27 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:47:17 +0900

    [rubygems/rubygems] Only platforms are relevant here

    https://github.com/rubygems/rubygems/commit/4b6f07f634

commit 00389b664bc6f5faaaaef9ddb2fb706052a20de4
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-12 22:53:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-15 16:47:16 +0900

    [rubygems/rubygems] Fix false positive warning about insecurely materialized gem

    In frozen mode, the previous logic would not set the platform locked
    originally in the materialized specification, and that would trigger the
    warning about insecure materialization incorrectly.

    https://github.com/rubygems/rubygems/commit/a18001e10c

commit 72dc16aa65a9d46f032d7a8d0292f5a5df6aade5
  Author:     Luke Gruber <luke.gru@gmail.com>
  AuthorDate: 2025-04-03 02:04:49 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-15 16:34:22 +0900

    Add a test for moving composite object parts

commit 698ef864a59004f468c77534d59e51e862ec2624
  Author:     Tanaka Akira <akr@fsij.org>
  AuthorDate: 2025-04-15 15:55:40 +0900
  Commit:     Tanaka Akira <akr@fsij.org>
  CommitDate: 2025-04-15 15:55:40 +0900

    `IO.select` accepts +Float::INFINITY+ as a timeout argument.

    matz accepted at the developper meeting 2024-07-11.

commit e1f544c1cf34787f139a973b934c9f535b201ea3
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-04-10 22:26:06 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-15 11:50:48 +0900

    Always look for the top-level RBasic in LLDB scripts

    `rp` and other commands were broken for me because they always showed
    the object as a T_NONE.

    The reason was that instead of returning the type `struct RBasic`,
    FindFirstType("struct RBasic") was returning
    `yjit::cruby::autogened::RBasic`.

    Explicitly asking for the top-level RBasic by prefixing it with `::` is
    enough to fix those commands.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13096

commit 6e184ebb5aa0461936a6db408a7fa48541a0e80d
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-04-10 22:24:52 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-15 11:50:48 +0900

    Fix LLDB heap_page command

    Move _append_command_output and _append_expression to LLDBInterface, and
    use it from HeapPageCommand after setting result.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13096

commit 0606046c1a3816eabb26b5de18942c02710eb28e
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-10 18:53:39 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-15 07:57:39 +0900

    Lazily create `objspace->id_to_obj_tbl`

    This inverse table is only useful if `ObjectSpace._id2ref` is used,
    which is extremely rare. The only notable exception is the `drb` gem
    and even then it has an option not to rely on `_id2ref`.

    So if we assume this table will never be looked up, we can just
    not maintain it, and if it turns out `_id2ref` is called, we
    can lock the VM and re-build it.

    ```
    compare-ruby: ruby 3.5.0dev (2025-04-10T09:44:40Z master 684cfa42d7) +YJIT +PRISM [arm64-darwin24]
    built-ruby: ruby 3.5.0dev (2025-04-10T10:13:43Z lazy-id-to-obj d3aa9626cc) +YJIT +PRISM [arm64-darwin24]
    warming up..

    |           |compare-ruby|built-ruby|
    |:----------|-----------:|---------:|
    |baseline   |     26.364M|   25.974M|
    |           |       1.01x|         -|
    |object_id  |     10.293M|   14.202M|
    |           |           -|     1.38x|
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13115

commit b68172caada45724a302f337334f29ebae5a0e1e
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-04-14 22:12:45 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-04-15 00:39:12 +0900

    Rename `f_optarg` to `f_opt_arg` for consistency in parser rules

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13114

commit 1c8154e5c9fc18878146330fb86f3216b4769aea
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-04-14 22:05:08 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-04-14 23:13:57 +0900

    Use call_op2 instead of call_op and tCOLON2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13113

commit c13ac4d615c28edc1580363c13b44eb7a73103f3
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2024-11-01 11:45:43 +0900
  Commit:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  CommitDate: 2025-04-14 18:28:09 +0900

    Assert the GVL is held when performing various `rb_` functions.

    [Feature #20877]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/11975

commit 4e970c5d5aee94c729541236c69792ec314f3731
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2024-11-21 06:38:13 +0900
  Commit:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  CommitDate: 2025-04-14 18:28:09 +0900

    Expose `ruby_thread_has_gvl_p`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/11975

commit 22667fcc38f6246f8d93f229097375f85e3efbab
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-04-14 16:46:11 +0900
  Commit:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  CommitDate: 2025-04-14 18:28:09 +0900

    Add `RUBY_VERSION_IS_3_5`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/11975

commit ad8cb532d52692fe72dea68a0aeaf48e5fc1fc02
  Author:     Sutou Kouhei <kou@clear-code.com>
  AuthorDate: 2025-04-13 13:18:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-14 16:18:48 +0900

    [ruby/strscan] Bump version

    https://github.com/ruby/strscan/commit/7b1eb1e4ed

commit 0db87b894365101581d7a560f019acd5acd434f0
  Author:     Jean byroot Boussier <jean.boussier+github@shopify.com>
  AuthorDate: 2025-04-13 12:42:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-14 16:18:47 +0900

    [ruby/strscan] Allow parsing strings larger than 2GiB
    (https://github.com/ruby/strscan/pull/147)

    For a reason unknown, even though `pos` is stored as a `long`, the
    `#pos` and `#pos=` treat it as an `int`, which prevent seeking into
    strings larger than 2GiB.

    https://github.com/ruby/strscan/commit/b76368416e

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

commit 38024772cafb3342a61d247c42d47d07afa97a8a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-11 03:32:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-14 16:17:50 +0900

    [rubygems/rubygems] Refine `bundle update --verbose` logs

    Don't mention "Found changes from the lockfile" because that's not
    really true in general.

    https://github.com/rubygems/rubygems/commit/0181c278e8

commit ce2640dde8c65d9e11c3bc2249c5cd5bb7d0dbce
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-11 04:03:44 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-14 16:17:50 +0900

    [rubygems/rubygems] Fix edge case making `bundle update` behave incorrectly

    If both a native and a generic version are locked, but the native
    version is incompatible with the running Ruby, Bundler will still keep
    the native version in the lockfile, since it could be potentially useful
    when using other rubies.

    However, when `bundle update` is run, this was not the case because the
    locked native gems were not using the right source when materializing.
    They were using the lockfile source instead of the Gemfile source, and
    that meant they could not be found when materializing, because the
    lockfile source always uses local mode so does not see them.

    The effect of this was normally that they were incorrectly removed from
    the lockfile and a strange "this spec has been possibly yanked" was
    printed in verbose mode. However, in certain situations (i.e., when the
    generic gem would bring extra dependencies), it could also make `bundle
    update` crash.

    The solution is, when adding this extra locked specs to the result after
    resolving, maybe sure they inherit the source from the resolved specs,
    so they can be found when materializing.

    `bundle install` did not have the issue because it passes locked specs
    to the resolver, and assigns the right source to them in
    `Definition#converge_locked_specs`.

    https://github.com/rubygems/rubygems/commit/91ce881fda

commit 66aa7139800e7ab5ef7d7a1b0dec73789936e672
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-10 23:42:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-14 16:17:49 +0900

    [rubygems/rubygems] Materialize specs just once in installer

    `Definition#specs` does the same thing but memoizes the result.

    https://github.com/rubygems/rubygems/commit/b62bf9fe41

commit c4a2f72b1bf0e43782ae38e0a456d8e18131c63a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-08 00:42:22 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-14 16:17:48 +0900

    [rubygems/rubygems] Fix `bundle lock --normalize-platforms` regression

    https://github.com/rubygems/rubygems/commit/458fa5dc4c

commit f65aad61f7c2b5ff15d10be9264d3b323b9e5145
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-14 10:24:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-14 11:20:34 +0900

    Update bundled_gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13112

commit 311167ee3a3c5fce6c4a3aa3a1aca18da0d55c88
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-13 21:59:26 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-14 07:03:59 +0900

    [ruby/etc] Suppress unused function warning

    https://github.com/ruby/etc/commit/410c8dd4ae

commit 6d00fa2270131b049a5502406868a1c7741812ad
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-13 21:48:34 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-14 07:03:59 +0900

    [ruby/etc] Check members only for defined structs

    https://github.com/ruby/etc/commit/15c2696794

commit e2559645421294d80315313d13385e8b948ab880
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-04-14 02:33:28 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-04-14 03:21:17 +0900

    Use user defined parameterizing rules `range_expr`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13111

commit 088fd968ed8af169964bed47cde2b25b58004396
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-04-14 02:13:58 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-04-14 03:01:01 +0900

    Add a new non-terminal symbol `ternary` to tidy up

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13110

commit e9966998200ba4786f5b6912047832c8889999bd
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-04-13 23:02:14 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-04-14 01:15:20 +0900

    Refactor assignment rules to remove unnecessary lhs parameter

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13109

commit 3700ae2e99a879a2b413c3132c95d933386c4e24
  Author:     Haruna Tsujita <82350582+haruna-tsujita@users.noreply.github.com>
  AuthorDate: 2025-04-13 20:46:40 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-13 20:46:40 +0900

    Fix typos `finised` -> `finished` (#13104)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 8c9cd65d8203cbae8f95a945669ee6215a0287e1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-13 16:53:18 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-13 16:53:18 +0900

    Fix unnecessary `false` in `CLEANLIBS`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13107

commit cfa74dda4547c7ef4d3510b729bad8cc6299e523
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-04-13 16:00:08 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-13 16:00:08 +0900

    Update bundled gems list as of 2025-04-13

commit 29b26fd3e7a881399b69665184be41ee6d47da6f
  Author:     Daniel Colson <danieljamescolson@gmail.com>
  AuthorDate: 2025-04-13 03:04:57 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-04-13 11:44:49 +0900

    Fix macro for disabled match cache

    The `MEMOIZE_LOOKAROUND_MATCH_CACHE_POINT` macro needs an argument
    otherwise we end up with:

    ```
    ../regexec.c:3955:2: error: called object type 'void' is not a function or function pointer
     3955 |         STACK_POS_END(stkp);
          |         ^~~~~~~~~~~~~~~~~~~
    ../regexec.c:1680:41: note: expanded from macro 'STACK_POS_END'
     1680 |     MEMOIZE_LOOKAROUND_MATCH_CACHE_POINT(k);\
          |     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~^
    ../regexec.c:3969:7: error: called object type 'void' is not a function or function pointer
     3969 |       STACK_POP_TIL_POS_NOT;
          |       ^~~~~~~~~~~~~~~~~~~~~
    ../regexec.c:1616:41: note: expanded from macro 'STACK_POP_TIL_POS_NOT'
     1616 |     MEMOIZE_LOOKAROUND_MATCH_CACHE_POINT(stk);\
          |     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~^
    ```

    The macro definition with the match cache enabled already has the
    correct argument. This one is for when the match cache is disabled (I
    had disabled it while trying to learn more about how it works.)

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13105

commit 543dd77cc39d16a45693d35af670995f7e66ce36
  Author:     viralpraxis <iaroslav2k@gmail.com>
  AuthorDate: 2025-04-10 17:56:25 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-13 02:43:57 +0900

    [ruby/prism] Fix parsing rescued exception via indexed assignment

    Given this code

    ```ruby
    begin
      raise '42'
    rescue => A[]
    end
    ```

    Prism fails with this backtrace

    ```
    Error: test_unparser/corpus/literal/rescue.txt(Prism::ParserTest): NoMethodError: undefined method `arguments' for nil
    prism/lib/prism/translation/parser/compiler.rb:1055:in `visit_index_target_node'
    prism/lib/prism/node.rb:9636:in `accept'
    prism/lib/prism/compiler.rb:30:in `visit'
    prism/lib/prism/translation/parser/compiler.rb:218:in `visit_begin_node'
    ```

    Seems like

    ```diff
    -            visit_all(node.arguments.arguments),
    +            visit_all(node.arguments&.arguments || []),
    ```

    fixes the problem.

    https://github.com/ruby/prism/commit/76d01aeb6c

commit a35a101b4cd393aa4947eea872c71f0f7f0cd3f0
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-04-08 20:38:18 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-04-13 01:23:39 +0900

    Change the indent after lhs in generation rules from spaces to tabs

    Change the indent to match the characters used in other generation rules. This makes it easier to find lhs.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13082

commit 3628e9e30d3809da67eb38b9d19fa99f8a999eaa
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-04-11 03:53:49 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2025-04-12 02:28:26 +0900

    Remove unused field on Thread struct

    It looks like stat_insn_usage was introduced with YARV, but as far as I
    can tell the field has never been used.  I think we should remove the
    field since we don't use it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13100

commit 0a35c5b4d9add69251590e3902a5d861df49e142
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-11 12:20:27 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-11 13:24:03 +0900

    Restore Windows 2022 build with VS2019 toolset

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13103

commit 8a15f806532fd1912b930abdcec6efac33f438b8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-11 11:37:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-11 12:18:56 +0900

    Fixed wrong usage of matrix.vs. That label is os version, not vs version

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13102

commit 0e792793277f3bb67ec58369436a57c0cb757a4d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-11 11:11:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-11 11:11:38 +0900

    Note the detailed version of Visual Studio

commit a2b39e5ca686b677b63be2b1ab8baa5a1b8df08d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-11 11:01:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-11 11:01:05 +0900

    Added instruction for autocrlf issue of Git on Windows

commit 1bd029b1eaa76496f376d92059db5f0b355ad03b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-11 10:55:31 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-11 10:55:31 +0900

    Note the detailed version of Windows SDK

commit af69421c91abc49390e8741870fac63513efbc0b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-11 10:49:26 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-11 10:49:26 +0900

    Added instruction for MSYS2 without RubyInstaller-Devkit

commit f13e86a70edffe9af9b8bca15a0a9652cf143386
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-04 10:03:50 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-04-11 03:33:46 +0900

    Allow gdb's rp to work on classes offline

    It's useful to be able to get information about classes without a
    running process, ie. when debugging a coredump.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13099

commit e3dd766e991892f1e2c0191ab6648eb0872a641c
  Author:     HoneyryderChuck <cardoso_tiago@hotmail.com>
  AuthorDate: 2024-10-30 02:58:27 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-11 00:58:04 +0900

    [ruby/resolv] refactoring class-hash to be ractor-safe

    mutable constants can't be shared across ractors; this changes that design to define the required variables as constants on the Resource class, which makes them reachable using ractors; the ClassHash is kept in order not to break integrations relying on its existence, but under the hood it's doing the same thing

    https://github.com/ruby/resolv/commit/639c01dc7f

commit 54a85caed4b364df5a7dd25795957b20b8e50f8e
  Author:     HoneyryderChuck <cardoso_tiago@hotmail.com>
  AuthorDate: 2024-10-29 23:43:55 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-11 00:58:03 +0900

    [ruby/resolv] config read from file should return frozen data!

    https://github.com/ruby/resolv/commit/afb57f40a1

commit 756479324fcbf609b401cefafd2911268d4a7851
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-08 23:24:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-10 19:21:51 +0900

    Sync Bundler and adapt to new spec setup

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13083

commit 684cfa42d77f8b667333f5efa3bd52463985b9d4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-10 17:50:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-10 18:44:40 +0900

    Avoid to infinite require loop for irb.

    if irb and that dependency are broken, it caused infinite loop with force_activate("irb").

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13093

commit 8003a06854fed5e46d20ed310488294b96537da8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-10 17:39:56 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-10 17:39:56 +0900

    [DOC] Use slashes in mingw confiure examples

    To show that mingw `sh` expects forward slashes as path separators, not
    backslashes, configure in another directory than the source directory.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13092

commit 08ce6268ee1690f003af40b9357272d43e990d75
  Author:     Xavier Noria <fxn@hashref.com>
  AuthorDate: 2025-02-17 04:30:40 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-10 17:33:36 +0900

    Document order of execution const_added vs inherited

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12759

commit b47a04eb9151a9fa59979fbaf20deeb404822959
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-10 16:02:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-10 17:29:39 +0900

    Refactor bundled condition

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12847

commit 598b0e8b72930c372a22b3db5da17bd69871be20
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-04 18:46:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-10 17:29:39 +0900

    The current force_activate always fails without Gemfile

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12847

commit 3390b6a515c4195905ef3be715fb611cce7ccaf5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-04 18:44:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-10 17:29:39 +0900

    Added simple failing example

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12847

commit c5c0bb5afcbbc054c9e8f4e4b9209253d42f7326
  Author:     Xavier Noria <fxn@hashref.com>
  AuthorDate: 2025-04-09 05:29:05 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-10 17:20:31 +0900

    Restore the original order of const_added and inherited callbacks

    Originally, if a class was defined with the class keyword, the cref had a
    const_added callback, and the superclass an inherited callback, const_added was
    called first, and inherited second.

    This was discussed in

        https://bugs.ruby-lang.org/issues/21143

    and an attempt at changing this order was made.

    While both constant assignment and inheritance have happened before these
    callbacks are invoked, it was deemed nice to have the same order as in

        C = Class.new

    This was mostly for alignment: In that last use case things happen at different
    times and therefore the order of execution is kind of obvious, whereas when the
    class keyword is involved, the order is opaque to the user and it is up to the
    interpreter.

    However, soon in

        https://bugs.ruby-lang.org/issues/21193

    Matz decided to play safe and keep the existing order.

    This reverts commits:

        de097fbe5f3df105bd2a26e72db06b0f5139bc1a
        de48e47ddf78aba02fd9623bc7ce685540a10743

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13085

commit 0d6263bd416338a339651fb97fe4d62701704c4b
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-04-09 19:49:21 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-04-09 23:45:54 +0900

    Fix coverage measurement for negative line numbers

    Fixes [Bug #21220]

    Co-Authored-By: Mike Bourgeous <mike@mikebourgeous.com>
    Co-Authored-By: Jean Boussier <jean.boussier@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13089

commit ce0d5cc06952317e8b0810ad978d6424f7ed9f6d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-09 19:14:36 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-09 19:14:36 +0900

    Refine dirname test on Windows

    - Compare with the root of the target file
    - Fix root path of UNC path

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13090

commit 5cf7d948ad4b8b365092673d48e3be16fcf08a10
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-04-09 19:13:58 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-09 19:13:58 +0900

    [DOC] Fix contributing link

    It moved in https://github.com/ruby/ruby/pull/13012 but wasn't updated here

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13088

    Merged-By: nobu <nobu@ruby-lang.org>

commit 9f61541f7624298be0c379ff61b66fc8470423e2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-09 15:18:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-09 15:51:08 +0900

    Re-enabled to test at win32ole

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13087

commit 8ab517698a76238d0afc7669b0ea1d5c6c1c0391
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-09 10:31:33 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-09 10:31:33 +0900

    sed is not requirement now

commit 9e93759b999c4fca219b3682eaf7964fa65f3bf0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-09 10:20:22 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-09 10:20:22 +0900

    Restore assertion that is not related mswin platform

commit ab4a25e48e351962d0d183d474c8b6d394123be6
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-04 19:22:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-09 08:11:10 +0900

    [rubygems/rubygems] Follow up to removal of rubyinstaller2 workaround

    https://github.com/rubygems/rubygems/commit/5b312fd040

commit ae45a7a952c232be66cd08b8c2df62c5fc741ab0
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-07 20:10:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-09 08:11:03 +0900

    [ruby/json] Cleanup jeaiii-ltoa to not need pragmas

    https://github.com/ruby/json/commit/97f2924d0a

commit b1362e26c7375a6fe3f30437b23e6e9fc28e35ab
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-07 19:44:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-09 08:11:03 +0900

    [ruby/json] Suppress -Wunknown-pragmas warnings

    https://github.com/ruby/json/commit/97f47d1cfd

commit d5f94941d87743d6563fa1a038665917dea70201
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2025-04-08 22:03:06 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-09 02:46:42 +0900

    [ruby/openssl] Fix the tests using SHA-1 Probabilistic Signature Scheme (PSS) parameters.

    Fedora OpenSSL 3.5 on rawhide stopped accepting SHA-1 PSS[1] parameters.
    This is different from the SHA-1 signatures which Fedora OpenSSL stopped
    accepting since Fedora 41.[2]

    This commit fixes the following test failures related to the SHA-1 PSS
    parameters with Fedora OpenSSL 3.5.
    Note these failures are the downstream Fedora OpenSSL RPM specific. The tests
    pass without this commit with the upstream OpenSSL 3.5.

    ```
    $ rpm -q openssl-libs openssl-devel
    openssl-libs-3.5.0-2.fc43.x86_64
    openssl-devel-3.5.0-2.fc43.x86_64

    $ bundle exec rake test
    ...
    E
    ===============================================================================================
    Error: test_sign_verify_options(OpenSSL::TestPKeyRSA): OpenSSL::PKey::PKeyError: EVP_PKEY_CTX_ctrl_str(ctx, "rsa_mgf1_md", "SHA1"): digest not allowed (digest=SHA1)
    /mnt/git/ruby/openssl/test/openssl/test_pkey_rsa.rb:113:in 'Hash#each'
    /mnt/git/ruby/openssl/test/openssl/test_pkey_rsa.rb:113:in 'OpenSSL::PKey::PKey#sign'
    /mnt/git/ruby/openssl/test/openssl/test_pkey_rsa.rb:113:in 'OpenSSL::TestPKeyRSA#test_sign_verify_options'
         110:       "rsa_pss_saltlen" => 20,
         111:       "rsa_mgf1_md" => "SHA1"
         112:     }
      => 113:     sig_pss = key.sign("SHA256", data, pssopts)
         114:     assert_equal 256, sig_pss.bytesize
         115:     assert_equal true, key.verify("SHA256", sig_pss, data, pssopts)
         116:     assert_equal true, key.verify_pss("SHA256", sig_pss, data,
    ===============================================================================================
    E
    ===============================================================================================
    Error: test_sign_verify_pss(OpenSSL::TestPKeyRSA): OpenSSL::PKey::RSAError: digest not allowed (digest=SHA1)
    /mnt/git/ruby/openssl/test/openssl/test_pkey_rsa.rb:191:in 'OpenSSL::PKey::RSA#sign_pss'
    /mnt/git/ruby/openssl/test/openssl/test_pkey_rsa.rb:191:in 'OpenSSL::TestPKeyRSA#test_sign_verify_pss'
         188:     data = "Sign me!"
         189:     invalid_data = "Sign me?"
         190:
      => 191:     signature = key.sign_pss("SHA256", data, salt_length: 20, mgf1_hash: "SHA1")
         192:     assert_equal 256, signature.bytesize
         193:     assert_equal true,
         194:       key.verify_pss("SHA256", signature, data, salt_length: 20, mgf1_hash: "SHA1")
    ===============================================================================================
    ...
    577 tests, 4186 assertions, 0 failures, 2 errors, 0 pendings, 3 omissions, 0 notifications
    ```

    [1] https://en.wikipedia.org/wiki/Probabilistic_signature_scheme
    [2] https://fedoraproject.org/wiki/Changes/OpenSSLDistrustSHA1SigVer

    https://github.com/ruby/openssl/commit/e0e771b76f

commit 5aa05f179c028981950cb5f40112ce058c5a40cd
  Author:     Eileen <eileencodes@users.noreply.github.com>
  AuthorDate: 2025-04-09 01:52:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-09 01:52:49 +0900

    Fix lldb debug scripts (#13048)

    In ruby/ruby#13008 `RVALUE` was removed without replacement. This means
    the lldb scripts that relied on `RVALUE` stopped working.

    I updated the ones that were using it just for the bytesize to use
    `slot_size` and then round to the nearest power of 40. We can't use
    `slot_size` directly because in debug mode it's `48` but `RVALUE` is
    `40` bytes.

    For the `as_type` method, I updated it to check the type. It's only used
    for `bignum` and `array` so that's a simple change.

    Lastly, for the `dump_page` method I replaced it with `struct free_slot`
    since that's looking at the freelist.

    `struct RVALUE` has been removed from all the scripts and I verified
    that `rp` is fixed. I'm not confident the `dump_page` method is fixed,
    the freelist looks off, but for now this gets us closer.

  Notes:
    Merged-By: eileencodes <eileencodes@gmail.com>

commit b68fe530f1880ed314099b61a70e3c0b1ee7cf6d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-08 15:45:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-08 15:46:45 +0900

    Windows 11 24H2 with VS 2019 16.11.45 couldn't handle long name test

    ```
      2) Error:
    TestDir#test_children_long_name:
    Test::Unit::ProxyError: No such file or directory @ apply2files - C:/Users/hsbt/AppData/Local/Temp/rubytest.zxydnz/d20250408-35424-2b0o6e/bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb/c
        V:/github.com/ruby/ruby/test/ruby/test_dir.rb:653:in 'File.unlink'
        V:/github.com/ruby/ruby/test/ruby/test_dir.rb:653:in 'block in TestDir#test_children_long_name'
        V:/github.com/ruby/ruby/lib/tmpdir.rb:105:in 'Dir.mktmpdir'
        V:/github.com/ruby/ruby/test/ruby/test_dir.rb:646:in 'TestDir#test_children_long_name'
    ```

commit 10d6ee65542a756072afb7182216efff80aa97d7
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-08 15:20:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-08 15:46:45 +0900

    Skip some assertions of TestFileExhaustive#test_dirname with Windows platform.

    These assertions didn't handle drive letter of Windows

    ```
      1) Failure:
    TestFileExhaustive#test_dirname [V:/github.com/ruby/ruby/test/ruby/test_file_exhaustive.rb:1282]:
    <"V:/"> expected but was
    <"C:/">.
    ```

commit d17ab5a430d0068a9016746402b296ab7f87abe1
  Author:     Kunshan Wang <wks1986@gmail.com>
  AuthorDate: 2025-04-07 16:21:51 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-08 12:12:50 +0900

    [ruby/mmtk] Do root scanning in scan_vm_specific_roots

    We rely on scan_vm_specific_roots to reach all stacks via the following
    path:

        VM -> ractors -> threads -> fibers -> stacks

    https://github.com/ruby/mmtk/commit/0a6a835aaa

commit b3b1d7b2952037727abfa66236d43e434003524a
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-27 10:23:04 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-04-08 08:56:44 +0900

    Remove spinlock in dtoa's Balloc, use xmalloc

    The spinlock here performs poorly when there are multiple Ractors. The
    improvement on single threaded performance doesn't seem that
    significant, so I think we should just use malloc.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12991

commit 4646ab89179aa3dac917a16aaa16533548ad33d9
  Author:     Kanstantsin Shautsou <kanstantsin.sha@gmail.com>
  AuthorDate: 2025-04-07 20:02:46 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-07 23:37:39 +0900

    Use correct warn method

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13079

commit e3abdfbc84fe1da62f309e260e574612a7b13473
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-04-06 04:34:01 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-04-07 22:41:11 +0900

    Skip test_heaps_grow_independently for MMTk

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13061

commit d4406f0627c78af31e61f9e07dda9151e109dbc4
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-04-04 05:43:09 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-04-07 22:41:11 +0900

    Grow GC heaps independently

    [Bug #21214]

    If we allocate objects where one heap holds transient objects and another
    holds long lived objects, then the heap with transient objects will grow
    along the heap with long lived objects, causing higher memory usage.

    For example, we can see this issue in this script:

        def allocate_small_object = []
        def allocate_large_object = Array.new(10)

        arys = Array.new(1_000_000) do
          # Allocate 10 small transient objects
          10.times { allocate_small_object }
          # Allocate 1 large object that is persistent
          allocate_large_object
        end

        pp GC.stat
        pp GC.stat_heap

    Before this change:

        heap_live_slots: 2837243
        {0 =>
          {slot_size: 40,
           heap_eden_pages: 1123,
           heap_eden_slots: 1838807},
         2 =>
          {slot_size: 160,
           heap_eden_pages: 2449,
           heap_eden_slots: 1001149},
        }

    After this change:

        heap_live_slots: 1094474
        {0 =>
          {slot_size: 40,
           heap_eden_pages: 58,
           heap_eden_slots: 94973},
         2 =>
          {slot_size: 160,
           heap_eden_pages: 2449,
           heap_eden_slots: 1001149},
        }

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13061

commit 432e5fa7e4ad57e0d8dcfcec29f0426aac7aedb4
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-04 19:25:03 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-07 19:00:09 +0900

    prism_compile.c: Avoid zero length allocation

    The constant pool may be empty.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13068

commit d485638a08a4561cd2f9c28d29b6d08d43dc5621
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-07 13:56:36 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-07 15:10:58 +0900

    Allow win32ole test failure

    ```
    D:/a/ruby/ruby/src/gems/src/win32ole/test/win32ole/test_win32ole_event.rb:80:in 'TestWIN32OLE_EVENT_SWbemSink#default_handler': undefined method '+' for nil (NoMethodError)
    ```

    https://github.com/ruby/ruby/actions/runs/14299035797/job/40072083885?pr=13078

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13078

commit f70bf7840370c4739ba11ddfdc35297086257170
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-07 10:44:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-07 15:10:58 +0900

    Fixed wrong condition to avoid flaky ractor_test.rb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13078

commit be5dea972002b4d26a736f9b40fad7aa0fcf0fec
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-07 10:37:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-07 15:10:58 +0900

    Rename test command for test-unit

    https://github.com/test-unit/test-unit/commit/b7d3c32f6e334e1823e30c053c2268893cf073ef

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13078

commit a4b4dad4badee2cf46dbc3da20d211c520fb79cb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-07 10:36:22 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-07 15:10:58 +0900

    Update bundled_gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13078

commit 3a7b9ca93b91dcc086b9ac8b9957e59268f9493b
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-04-06 18:36:06 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-04-07 11:08:10 +0900

    Fix `Integer.sqrt` to never exceed actual value

    `Integer.sqrt` uses `sqrt(3)` from libm for small values.
    This method must return a value less than or equal to the actual integer
    square root, but libm's sqrt does not always guarantee that.

    This change corrects that by decrementing the result if necessary.

    Fixes [Bug #21217]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13076

commit e25889951f39aff6e3c16ecee10e678912454e69
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-06 12:24:23 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-06 12:24:23 +0900

    Ensure builtin binaries are aligned to ibf_header

    Since IBF result string size should be multiple of 4, this should not
    increase the binary size actually.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13075

commit b5ac483d9546f5e3bc8d72ef3efb8c90c9452069
  Author:     Naoto Ono <onoto1998@gmail.com>
  AuthorDate: 2025-04-06 09:38:58 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-06 09:38:58 +0900

    Fix the if condition to skip test_ractor.rb correctly (#13067)

    Follow-up for https://github.com/ruby/ruby/commit/a2b03ba7cb721d698bebee74c535dea4583a9c28

  Notes:
    Merged-By: ono-max <onoto1998@gmail.com>

commit 229784d160452dcdaa85ae4b5c5fae5c2728324b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-05 10:29:58 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-05 10:31:20 +0900

    [Bug #21150] macOS: unwinding coroutine workaround is only for arm64

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13072

commit 085cc6e43473f2a3c81311a07c1fc8efa46c118b
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-04 20:28:51 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-04 23:26:29 +0900

    Ractor: revert to moving object bytes, but size pool aware

    Using `rb_obj_clone` introduce other problems, such as `initialize_*`
    callbacks invocation in the context of the parent ractor.

    So we can revert back to copy the content of the object slots,
    but in a way that is aware of size pools.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13070

commit eb765913c108fa0e71ab7f9852457a914a7d98f0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-04 19:34:04 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-04 19:34:04 +0900

    Console Cntl event is sent to root process sharing the console

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13069

commit cec45aedb5ce7cf9f263421712ad5abcf6404380
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-04 15:21:11 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-04 16:24:49 +0900

    Cannot send signal to process group on Windows

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13069

commit d22e7660427e1e9929e8444135199b5c3e731246
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-04 10:59:51 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-04 16:24:48 +0900

    Cannot send `SIGTERM` to another process on Windows

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13069

commit 0251abca7f19c393d756e77ee059a4357a8f2f20
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-04 14:23:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 14:23:25 +0900

    Fixed mismatched indentation

commit 705a95323e7bd85fdade2970976fd7d87a1ccf2e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-04 14:21:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 14:21:05 +0900

    Removed unused variable

commit b4a94011ca018c2e7b105534e299033106793158
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-04 11:58:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 11:58:59 +0900

    Hardening auto-merge workflow

    https://docs.github.com/en/code-security/dependabot/working-with-dependabot/automating-dependabot-with-github-actions#enabling-automerge-on-a-pull-request

commit 05e74543f6b0dca882e4324d3577b68fe1c231e1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-04 08:51:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 10:21:31 +0900

    Update bundled_gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13066

commit 710bf4a47246c973b597f6d948dc7279babe93f4
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-03 23:06:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 08:54:47 +0900

    [rubygems/rubygems] Rubyinstaller2 fixed this

    https://github.com/rubygems/rubygems/commit/08b3c48f41

commit f8c0225971f93fdbb546bf4f921619357446135f
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-02 02:35:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 08:54:47 +0900

    [rubygems/rubygems] Improve bug report instructions

    * Explicitly recommend copying full command output and not just the bug
      report template part.
    * Include quadruple quotes in the "What actually happened section" and
      tell users to copy full command output inside. Hopefully quadruple
      quotes will make the error report information (which includes triple
      quotes itself) render fine by default.
    * Avoid "actually" as per quality_spec.rb recommendation.

    https://github.com/rubygems/rubygems/commit/0a3bf2edb1

commit 6b5e187d0eb07994fee7b5f0336da388a793dcbb
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-04-04 02:20:20 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-04 02:58:30 +0900

    [ruby/openssl] pkcs7: fix test failure on RHEL 9

    The test case test_split_content fails on RHEL 9 and Fedora 41 because
    their OpenSSL packages do not accept SHA-1 signatures. This was only
    caught after commit https://github.com/ruby/openssl/commit/69fd7f886313 added the missing assertion.

    While the example PKCS#7 structures could be simply regenerated with
    SHA-256, this test case could be simplified because it is checking two
    different things.

    Replace test_split_content with separate test cases: one verifying
    signed-data authenticatedAttributes and another for decoding BER input.

    Fixes https://github.com/ruby/openssl/issues/875

    https://github.com/ruby/openssl/commit/b32406b0c1

commit 3911113bc4d441d01ad888fbaaee494c9386ebe0
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-04-03 22:02:04 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-04 02:58:29 +0900

    [ruby/openssl] pkcs7: update test case test_graceful_parsing_failure

    Using test_pkcs7.rb as an example invalid input is not reliable because
    we may happen to include a valid PKCS#7 PEM block in a heredoc.

    https://github.com/ruby/openssl/commit/76fead26d2

commit 137b51e4d3dff93e0101f776ac05af63aca9b778
  Author:     John Hawthorn <john.hawthorn@shopify.com>
  AuthorDate: 2025-04-03 04:03:44 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-04-04 02:39:47 +0900

    Remove rb_gc_start from cancel_single_ractor_mode

    In 307732ccee7f9f28f8422bab2f839da021d8cdec Ractors were changed to
    explicitly run GC when the first non-main one was activated in order to
    disable the transient heap. Theap no longer exists so I don't think we
    need to do this.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13047

commit 5eb3efcf2de300e4ad1d3ce5de8ea756063b9a28
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-04-04 00:31:13 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-04-04 02:39:47 +0900

    Fix timeline_value not being marked in test

    T_DATA with a NULL pointer are not marked. Let's wrap 1 instead to
    ensure that our mark function is actually run.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13047

commit 4aa74b605c9960192c30c711fa6e982727eb8d1b
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-03 23:07:34 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-03 23:57:57 +0900

    compile.c: avoid allocating 0 length call_data

    if `body->ci_size` is `0`, there's no point allocating 0B,
    it just wastes an entry in the allocator.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13059

commit fab133e629c507f4add4a7dde2e0ba12b7ec281c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 19:30:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 20:03:18 +0900

    Use EnvUtil.apply_timeout_scale

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13058

commit 3f152ce767dcc2bda2232d35d29eaecf97932627
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 19:07:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 20:03:18 +0900

    Extend open_timeout for test failure on s390x

    https://rubyci.s3.amazonaws.com/s390x/ruby-master/log/20250403T060004Z.fail.html.gz

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13058

commit 1dddc6c78b5f6dc6ae18ee04ebe44abfce3b0433
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-02 17:32:37 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-04-03 16:56:24 +0900

    Remove no longer used union

    IMEMO_NEW takes just one memo value, min/max argc are assigned
    directly and packed argc is not used.

commit 29dafa5fc21343803127dda7d608f1f1f7908e7b
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-04-03 01:27:47 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2025-04-03 11:31:05 +0900

    Fix assertion failure with anonymous splats

    When calling a method that accepts an anonymous splat and literal
    keywords without any arguments, an assertion failure was previously
    raised. Set rest_index to 0 when setting rest to the frozen hash,
    so the args_argc calculation is accurate.

    While here, add more tests for methods with anonymous splats with
    and without keywords and keyword splats to confirm behavior is
    correct.

    Also add a basic bootstrap test that would hit the previous assertion
    failure.

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13046

commit b8e2bec9142a3e0153b756379ecb11853e86f1af
  Author:     Herwin <herwinw@users.noreply.github.com>
  AuthorDate: 2025-04-02 18:50:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 10:14:58 +0900

    Grammar fix in doc/exceptions.md: there => they're

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13040

commit 1598a2cab817b3264c9e38b258e4a650738cb521
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 09:40:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 10:12:34 +0900

    Enforce to use CMake 3 because CMake 4 is not compatible to build libyaml via vcpkg

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13049

commit d543fda4335ea1cafd56b3976f089cfbc3d20597
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-31 17:53:01 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-03 05:53:34 +0900

    [ruby/prism] Be explicit in tests which files `parser` can't parse

    It also updates to latest `parser`, which allows numbered
    parameters in pattern matching pin,
    passing `patterns.txt` and `case.txt`

    https://github.com/ruby/prism/commit/bdcc8b3dc5

commit 334c261cc9ee125c4c4bfc65dec2e571af8944a2
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-30 20:28:36 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-03 05:51:54 +0900

    [ruby/prism] Fix parser translator when splatting in pattern matching pin

    Because it ends up treating it as a local variable, and `a.x`
    is not a valid local variable name.

    I'm not big on pattern matching, but conceptually it makes sense to me
    to treat anything inside ^() to not be
    pattern matching syntax?

    https://github.com/ruby/prism/commit/80dbd85c45

commit fe9ebb245644a38392fd26b5ec18efd8e549b154
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-03 00:41:33 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-03 01:50:14 +0900

    vm_core.h: unify YJIT ifdefs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13044

commit 3a7b03242f4f8f31899ffcf5e4a253ae6f01e96a
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-04-01 22:09:04 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-04-03 01:10:56 +0900

    [DOC] Tweaks for Hash doc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13029

commit 2a55cc3fb87f43b44dfb820f325bed60f01db236
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-04-03 01:03:17 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-03 01:03:17 +0900

    [DOC] Tweaks to String::try_convert

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13030

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit ce1dfe81c2ef148aa6f0f2bb51ee373f68cefd04
  Author:     Kunshan Wang <wks1986@gmail.com>
  AuthorDate: 2025-04-01 13:07:47 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-04-02 23:47:52 +0900

    [DOC] Doc for Thread::ConditionVariable

    Documented the necessity of calling `wait` in a loop.  We modified the
    example to demonstrate the idiomatic use, and added a third thread `a2`
    to demonstrate another reason that necessitates the loop.

    Mentioned spurious wake-up in the doc.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13024

commit 580aa60051773e3512121088eb8ebaee8ce605ea
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-02 19:08:39 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-04-02 20:24:22 +0900

    Improve backtrace of errors raised by `Socket.tcp_with_fast_fallback`

    [Bug #21211]

    Socket errors raised from background threads are hard to track down because
    their backtrace starts from the spawned thread.

    To solve this we can raise a new error with the old one as `cause`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13041

commit 43ee4a50d91652c0909b97fe7195af8e87600971
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-02 15:21:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-02 16:24:47 +0900

    Fixup comment for Windows platform, not Solaris

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13037

commit e71192da69f733a987a5db5692f4a33b303ade0d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-02 14:53:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-02 16:24:47 +0900

    Removed Solaris conditions from optional and shared directories

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13037

commit 3d4ea45411cba9d14f061aa5a26a0e146f3d7304
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-02 14:52:22 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-02 16:24:47 +0900

    Removed Solaris conditions from library directory

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13037

commit 8cb61b00fd0c5e87163703fc93e5303ca413b79e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-02 14:38:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-02 16:24:47 +0900

    Removed Solaris conditions from core directory

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13037

commit 6bd5a51ab5a2b1d33fa586cb2969b25d8d68c121
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-02 13:38:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-02 16:24:47 +0900

    Removed Solaris conditions from test files

    We no longer execute those files with Solaris platforms.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13037

commit ca97302dd404070bf971767914b6e4855b4de8a9
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-04-02 16:01:44 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-02 16:01:44 +0900

    Update bundled gems list as of 2025-04-01

commit 938db05361585fb4a2da38bc62d1ea36ea451bf6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-31 17:35:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-02 10:52:26 +0900

    Removed the warning targets for Ruby 3.1 because 3.1 is already EOL

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13017

commit e4020133c88b358d4392d29058043cc5dbdb195b
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2025-04-01 23:57:55 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2025-04-02 05:45:08 +0900

    Remove incorrect assertion

    ractor_cache will always be NULL in this context

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13031

commit 6fbc32b5d0da31535cccc0eca1853273313a0b52
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-04-02 04:48:18 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-04-02 05:25:01 +0900

    GCC defines __linux__, not __LINUX__

    Fixes: 2c6512fe67a275ce4d251f3c5d304bc523597f42

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13032

commit 30e5e7c005f4a0a2cd4b883ab8c2be48aa3bf6ed
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2025-04-01 20:01:49 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2025-04-02 01:11:01 +0900

    Revert "Fix jump buffer leak in setjmp handler in WASI builds"

    This reverts the following commits as it's causing OOM in some cases in
    ruby/ruby.wasm test suite.
    * 372515f33c908b36b3f5fbd2edcb34c69b418500
    * 3a730be8b464454878a42132f6fecb98ab4c1b5b

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13026

commit a671b25525279706d1fa2ee3b25ef45e3ec0eb89
  Author:     Naoto Ono <onoto1998@gmail.com>
  AuthorDate: 2025-04-01 18:20:13 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-01 18:20:13 +0900

    [Bug #21203] Skip TestGc#test_gc_parameter_init_slots since it is flaky (#13025)

    https://bugs.ruby-lang.org/issues/21203

    TestGc#test_gc_parameter_init_slots is a flaky test that fails intermittently. Until the issue with flakiness is resolved, I will skip it.

  Notes:
    Merged-By: ono-max <onoto1998@gmail.com>

commit 67a7d4a0a83638ac0c33bfb21d3d87d996946a45
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-01 15:20:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-01 15:58:24 +0900

    [rubygems/rubygems] Bump up minimum required version for cmake 4

    https://github.com/rubygems/rubygems/commit/3e77caeddf

commit cd1952484cc74e2171cd72eb46bb00b04c8daa60
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-01 03:20:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-01 13:31:48 +0900

    [rubygems/rubygems] Stay away from FileUtils.rm_rf in Bundler specs

    Instead, skip the spec when run by ruby-core. Maybe the root cause can
    be fixed at some point.

    https://github.com/rubygems/rubygems/commit/09594ae5b8

commit 79f3167e0b601656f651b247d6ca09e4cadfadcb
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-27 06:26:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-01 09:57:40 +0900

    [rubygems/rubygems] Let compact index response parser consistently return a mutable dependencies array

    That restores support for compact index dummy implementations that only lists
    versions, without checksums or dependencies.

    This format is undocumented, so we may want to get rid of it in the
    future. However, some of our tests rely on it, and some implementations
    did use it (gems.mutant.dev at least). And the way the code was written
    suggest that support was intentional.

    So for now, we should restore it.

    https://github.com/rubygems/rubygems/commit/0427d8c983

commit 92422576c6ffa21f8c68f7b9774f0297b8acae71
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-27 23:58:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-01 09:56:56 +0900

    Remove compact index response parser from Bundler

    It's available in RubyGems since 3.2.3 and we no longer support that old
    version.

commit fce2c386a5e3a49bf8863c7550e257e349ca093b
  Author:     Giacomo Benedetti <giacomo.bndt@gmail.com>
  AuthorDate: 2025-03-14 20:01:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-01 09:55:19 +0900

    [rubygems/rubygems] Sorting files in metadata for reproducibility

    https://github.com/rubygems/rubygems/commit/792117980b

commit 6d70847e27ccd3a92d8a22907531b8e1a38ca546
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-31 22:28:16 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-04-01 05:37:44 +0900

    Make free, memsize functions of IO::Buffer static

    They are not used outside of io_buffer.c, so we can make them static.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13022

commit 0fad0ce35ca0160288a64a8cc49e6dae1b199821
  Author:     Alexander Momchilov <alexander.momchilov@shopify.com>
  AuthorDate: 2025-03-31 23:28:24 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-04-01 04:57:33 +0900

    [ruby/prism] Use `xmalloc()`/`xfree()`

    https://github.com/ruby/prism/commit/bd9027f0ab

commit 2d9036498e775dbc8a5a9ba42a6ab02f1c43f2ac
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-31 21:50:10 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-04-01 03:49:40 +0900

    [DOC] Tweaks for Hash doc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13020

commit 765918d28317be34ec0c688a7742847801804e36
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-04-01 03:48:23 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-01 03:48:23 +0900

    [DOC] Tweaks for docs about contributing (#13012)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit cdb1bf1e53a8cbb67d273f5b09c3bec775f2c3eb
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-04-01 03:47:20 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-04-01 03:47:20 +0900

    [DOC] Tweaks for Hash#update

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12985

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit a61e7118e6da9798862b559661075bafce44b541
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2025-03-31 21:50:23 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2025-04-01 01:10:51 +0900

    Provide compaction support for argf_type

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13021

commit 6012145299cfa4ab561360c78710c7f2941a7e9d
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2025-03-31 19:38:16 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2025-04-01 01:10:37 +0900

    Mark rb_io_buffer_type references declaratively

    allowing them to support compaction and be moved.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13018

commit 8a475d15d6aec3618d075b66541b4bae663beac9
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-31 19:48:56 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-31 23:56:29 +0900

    Implement `dcompact` for Time objects

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13019

commit 7db0e07134c9ff9e1da090053041b670f3206de4
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-31 18:29:06 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-31 19:01:55 +0900

    Don't preserve `object_id` when moving object to another Ractor

    That seemed like the logical thing to do to me, but ko1 disagree.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13008

commit 0350290262ea0fbc4e1807901797ee8a6970c2b9
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 22:26:59 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-31 19:01:55 +0900

    Ractor: Fix moving embedded objects

    [Bug #20271]
    [Bug #20267]
    [Bug #20255]

    `rb_obj_alloc(RBASIC_CLASS(obj))` will always allocate from the basic
    40B pool, so if `obj` is larger than `40B`, we'll create a corrupted
    object when we later copy the shape_id.

    Instead we can use the same logic than ractor copy, which is
    to use `rb_obj_clone`, and later ask the GC to free the original
    object.

    We then must turn it into a `T_OBJECT`, because otherwise
    just changing its class to `RactorMoved` leaves a lot of
    ways to keep using the object, e.g.:

    ```
    a = [1, 2, 3]
    Ractor.new{}.send(a, move: true)
    [].concat(a) # Should raise, but wasn't.
    ```

    If it turns out that `rb_obj_clone` isn't performant enough
    for some uses, we can always have carefully crafted specialized
    paths for the types that would benefit from it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13008

commit 532b9246d3819b2a309992a20ff031f91ac3e5db
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-31 17:34:46 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-31 18:14:34 +0900

    Initialize ractor thgroup in `thread_do_start_proc`

    Followup: https://github.com/ruby/ruby/pull/13013

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13016

commit 5e421ce8d949a4f92568db359be0d188b66e58ca
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-31 02:18:34 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-31 17:25:52 +0900

    ractor: don't inherit the default thread group

    [Bug #17506]

    `Thread.current.group` isn't shareable so it shouldn't be inherited
    by the main thread of a new Ractor.

    This cause an extra allocation when spawning a ractor, which could
    be elided with a bit of extra work, but not sure if it's worth
    the effort.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13013

commit 502fcfcc46fe1362b30d311e2fc03bfe37a78dc8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-31 16:13:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 16:13:46 +0900

    stringio-3.1.6 has been released

commit a2b03ba7cb721d698bebee74c535dea4583a9c28
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-31 14:36:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 15:08:58 +0900

    Skip test_ractor.rb with ModGC workflow because this test is flaky

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13015

commit 679e3e5b333a36a6621ba03c9c10d66708318ecb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-31 14:10:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 14:42:59 +0900

    Specified commits for removing csv-filter executable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13014

commit 91973a595cb364301894e0821bbe83d6e614ab6a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-31 14:09:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 14:42:59 +0900

    Update bundled_gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13014

commit 397334ab673420db4e0fc7df38e64c6afca01a8f
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2025-03-31 13:07:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 14:06:27 +0900

    Bundle rbs-3.9.2

commit 83518d8d5e3106eb40617b1cbc98dc3b6fb625d2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-31 12:49:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 14:06:27 +0900

    Update rdoc-6.13.1

commit 0dae3edb347053fe7c456a95cf794cea4309fe53
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-31 12:47:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 14:06:27 +0900

    Also skip test_load(JSONSingletonTest)

commit 0a097e6e452014d63bdb6cc3d7b287e1a671d77f
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2025-03-24 17:37:07 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 14:06:27 +0900

    Fix `{}`

commit 3fb2006bf18228afbedd470e82bc0204c6e1d15e
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2025-03-24 10:16:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 14:06:26 +0900

    Skip RDoc tests

commit e47f6215545ce04d759f3b071a355a1bf7ff256b
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2025-03-24 09:55:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 14:05:32 +0900

    Bundle rbs-3.9.1

commit 372515f33c908b36b3f5fbd2edcb34c69b418500
  Author:     刘皓 <whiteaxe@tuta.io>
  AuthorDate: 2025-03-27 14:45:20 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2025-03-31 11:59:33 +0900

    Don't set `saved_ec.tag` to `NULL` in `cont_init()`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12995

commit 3a730be8b464454878a42132f6fecb98ab4c1b5b
  Author:     刘皓 <whiteaxe@tuta.io>
  AuthorDate: 2025-03-27 13:37:14 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2025-03-31 11:59:33 +0900

    Fix jump buffer leak in setjmp handler in WASI builds

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12995

commit 72fc9c7b1580251eac7d8db116df7f6e436be8b3
  Author:     刘皓 <whiteaxe@tuta.io>
  AuthorDate: 2025-03-27 13:34:27 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2025-03-31 11:59:33 +0900

    Fix stack pointer corruption in setjmp handler in WASI builds

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12995

commit dea505dea014c45062fb2963d4eb770be1497a4a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-25 22:46:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 09:39:22 +0900

    [rubygems/rubygems] Allow ruby platform to be remove also when dependencies have changed

    Since we will now add it back if the final resolution is compatible, we
    can also get this kind of edge case (`bundle add`) working.

    https://github.com/rubygems/rubygems/commit/cdc5ebec77

commit b2bcd360441c334f16148908684e9b409eac4949
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-25 02:19:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 09:39:22 +0900

    [rubygems/rubygems] Remove edge cases for not removing invalid platforms

    Instead, remove them anytime we find dependencies don't match the
    lockfile for a platform, and then add them back after resolution if
    they ended up being valid.

    https://github.com/rubygems/rubygems/commit/220bd77887

commit f72d5effb79a9957a0abd62c4f743e67cbf8e5ed
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-27 23:34:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 09:39:22 +0900

    [rubygems/rubygems] `SpecSet#add_extra_platforms!` doesn't need to return anything

    https://github.com/rubygems/rubygems/commit/9fd92ade54

commit 91df1795c5bc9659ff7cec6c8f5a1b3eade1145b
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-25 01:19:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 09:39:22 +0900

    [rubygems/rubygems] Split finding and removing invalid platforms

    I don't like traversing the array and modifying it at the same time
    while it seems to work.

    https://github.com/rubygems/rubygems/commit/6551c74c27

commit f8720b01d9500d890a5b2a499c5126b83951c3cb
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-28 16:53:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 09:39:22 +0900

    [ruby/json] Remove caller location assertions

    Fix: https://github.com/ruby/json/pull/781

    Tests are ran a bit differently in ruby/ruby
    and this assertion breaks.

    https://github.com/ruby/json/commit/0d4fc669ed

commit a7ab156d947960e4202a4fe96ea9c6a1d39c9260
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-31 09:05:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 09:39:22 +0900

    Revert "Relax assertion pattern for ruby repo"

    This reverts commit 09b94688731a73a4ee63969a22ba7d537223e02a.

commit a203603be0ac6d95fa4740c0c763d9cad46c844c
  Author:     Lorenzo Zabot <lorenzozabot@gmail.com>
  AuthorDate: 2025-03-29 18:45:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-31 09:16:18 +0900

    Correct typo in Ractor comment

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13011

commit d7e46543b5fc34487dbc2c784412af015dbe67f4
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-30 19:48:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-31 02:24:05 +0900

    [ruby/prism] Fix parser translator when pinning hash with string keys

    `StringNode` and `SymbolNode` don't have the same shape
    (`content` vs `value`) and that wasn't handled.

    I believe the logic for the common case can be reused.
    I simply left the special handling for implicit nodes in pattern matching
    and fall through otherwise.

    NOTE: patterns.txt is not actually tested at the moment,
    because it contains syntax that `parser` mistakenly rejects.
    But I checked manually that this doesn't introduce other failures.
    https://github.com/whitequark/parser/pull/1060

    https://github.com/ruby/prism/commit/55adfaa895

commit 052794bfe1970e90f4f4f9e37fc362dd27903a8d
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-23 02:17:27 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-31 02:22:41 +0900

    [ruby/prism] Accept a newline after the defined? keyword

    [Bug #21197]

    https://github.com/ruby/prism/commit/22be955ce9

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12999

commit 6b5aa432913c8aaef96513618d0edc73cdb6141c
  Author:     Samuel Chiang <sachiang@amazon.com>
  AuthorDate: 2025-03-19 10:33:32 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-30 22:46:28 +0900

    [ruby/openssl] Skip PKCS7 with indefinite length test in AWS-LC

    AWS-LC had been decoding the indefinite BER to an unusable output. We
    should skip the test until indefinite BER decoding in AWS-LC is
    properly fixed.

    Changes:
    1. AWS-LC will be looking to fix the parsing for indefinite BER
    constructed strings in AWS-LC soon, so I've marked the test as `pend`
    for now and removed the AWS-LC specific logic at the end.
    2. I've added an assertion to verify that `OpenSSL::PKCS7.verify`
    behaves correctly before doing content comparisons. I noticed this was
    failing initially in AWS-LC, but that will be fixed soon as well. This
    shouldn't effect OpenSSL/LibreSSL builds and should improve the test.

    https://github.com/ruby/openssl/commit/69fd7f8863

commit 9e87323ad00f393fbaa8b9e170248fe11bd652aa
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-27 06:00:20 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-30 06:05:21 +0900

    [DOC] Tweaks for Hash#values_at

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12989

commit dbc1ceca3264246ab2e7b47e06e5e62f0409051e
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-27 05:45:38 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-30 06:04:56 +0900

    [DOC] Tweaks for Hash#values

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12988

commit 4e3bc65e88f050563a49982ac0a5e57940def161
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-27 05:15:15 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-30 06:04:33 +0900

    [DOC] Tweaks for Hash#has_value?

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12986

commit a4a60195502add094fb52a587411bbd0c19facce
  Author:     tomoya ishida <tomoyapenguin@gmail.com>
  AuthorDate: 2025-03-29 20:46:43 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-29 20:46:43 +0900

    [Bug #21202] Fix wrong token concat while tokenizing nested unterminated heredoc (#13000)

  Notes:
    Merged-By: tompng <tomoyapenguin@gmail.com>

commit 549c7fe29d95394ccdc4387d24a4c4a48e30dad7
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-03-29 09:24:42 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-03-29 17:51:19 +0900

    Adjust indentation for user defined parameterized rule

    This PR just fixing indentation.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13010

commit 332f5d0b73cffb07c3e0002d31cc2c5d1b3fac1c
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-03-28 00:46:30 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-29 01:36:24 +0900

    Remove RUBY_FL_PROMOTED{0,1} from debugger scripts

    These flags were removed in d426343418aab6148706860bd1678ac309dc12c0 and
    print_flags is broken because of it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13006

commit 3aee7b982b283d2355c249b863d4f3570c929e26
  Author:     Richard Böhme <richard.boehme1999@gmail.com>
  AuthorDate: 2025-01-18 04:41:13 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2025-03-28 23:08:28 +0900

    Mark first argument to all C-API tracepoint functions as nonnull

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12553

commit 04ebedf7f0144e8d5b8b2cd9cd243a2581bf974c
  Author:     Richard Böhme <richard.boehme1999@gmail.com>
  AuthorDate: 2025-01-12 05:45:32 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2025-03-28 23:08:28 +0900

    Make rb_tracearg_(parameters|eval_script|instruction_sequence) public C-API

    This allows C-Extension developers to call those methods to retrieve
    information about a TracePoint's parameters, eval script and
    instruction sequence.

    Implements [Feature #20757]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12553

commit fc26004660a287b977e5481a09f6329ffa688357
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-03-28 13:34:32 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-03-28 14:19:33 +0900

    Remove test_retry_workers

    The test fails randomly for unknown reason.

    https://github.com/ruby/ruby/actions/runs/14121674932/job/39562945096?pr=12993
    ```
        1) Error:
      TestParallel::TestParallel#test_retry_workers:
      Test::Unit::ProxyError: execution expired (start: 2025-03-28 04:04:10 +0000, end: 2025-03-28 04:05:50 +0000)
          /home/runner/work/ruby/ruby/src/tool/test/testunit/test_parallel.rb:16:in 'TestParallel.timeout'
          /home/runner/work/ruby/ruby/src/tool/test/testunit/test_parallel.rb:225:in 'TestParallel::TestParallel#test_retry_workers'
    ```

    Maybe the workers do not respond "quit" request.

    We no longer use the retry mechanism, so just remove the test.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12993

commit 28c7ae66268c1f81441f8ed5fc0800337f0e3bcf
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-03-27 14:05:00 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-03-28 14:19:33 +0900

    Try avoiding "invalid byte sequence in UTF-8"

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12993

commit 12f8dda9e0c942584ba8672522f47d5b66179111
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-03-27 13:17:55 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-03-28 14:19:33 +0900

    Report the actual time waited for timeout errors in TestParallel

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12993

commit c3ca9313040c270cbc1c238ed67ec4b0c902c928
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-03-28 14:07:18 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-03-28 14:07:40 +0900

    TestRegexp#test_match_cache_positive_look_ahead_complex: Extend the timeout limit

commit 8582d93194d5878a5b1aefcaa8ece91910f1df82
  Author:     Naoto Ono <onoto1998@gmail.com>
  AuthorDate: 2025-03-28 12:58:09 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-28 12:58:14 +0900

    [ruby/etc] Skip TestEtc#test_ractor_parallel on ModGC workflow
    (https://github.com/ruby/etc/pull/55)

    https://bugs.ruby-lang.org/issues/21204

    TestEtc#test_ractor_parallel is only failing intermittently on ModGC workflow after 87fb0c4. So, we'll skip this test on ModGC workflow.

    https://github.com/ruby/etc/commit/fb037c5162

commit 1e715bd27a25b8803f8efbbfef7eb5912202b927
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-28 12:09:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    Skip failing rbs tests for deprecated JSON methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit 2ba37d24e8f8c7858a3db9df5fa9d1a1cb39181a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-28 12:02:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    spec/mspec/tool/wrap_with_guard.rb 'ruby_version_is ...3.5' spec/ruby/security/cve_2020_10663_spec.rb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit 09b94688731a73a4ee63969a22ba7d537223e02a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-28 11:57:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    Relax assertion pattern for ruby repo

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit 3bbb52f5c5fb086492c9799ea7b48675cfde50f1
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 23:07:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    [ruby/json] Add missing assert_deprecated_warning

    https://github.com/ruby/json/commit/1b16a82980

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit ec171b4075407d02698a445e169f57fd68a9dcfc
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 20:25:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    [ruby/json] Move `create_addtions` logic in Ruby.

    By leveraging the `on_load` callback we can move all this logic
    out of the parser. Which mean we no longer have to duplicate
    that logic in both parser and that we'll later be able to extract
    it entirely from the gem.

    https://github.com/ruby/json/commit/f411ddf1ce

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit e8c46f4ca5e6ba2638fbfc81fdb9d141cd88e99a
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-26 23:19:26 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    [ruby/json] JSON.load invoke the proc callback directly from the parser.

    And substitute the return value like `Marshal.load` doesm
    which I can only assume was the intent.

    This also open the door to re-implement all the `create_addition`
    logic in `json/common.rb`.

    https://github.com/ruby/json/commit/73d2137fd3

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit 80a59a62441c0938d0a29fcd5dd95f8024db6ddf
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 19:01:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    [ruby/json] Remove more dead code

    https://github.com/ruby/json/commit/eda239ad34

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit 756b75f2421008a46ee68390c683ca2c1a0ddc31
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 18:34:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    [ruby/json] Remove `Class#json_creatable?` monkey patch.

    https://github.com/ruby/json/commit/1ca7efed1f

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit 96ecac1e245aaac4484f69a731d2af4328760a8e
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 18:36:31 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    [ruby/json] Get rid of JSON::NOT_SET

    https://github.com/ruby/json/commit/760d922265

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit bba30bee6275601e14cde260e3a3c9545cebe6b7
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 18:16:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    [ruby/json] Remove outdated JSON.iconv

    https://github.com/ruby/json/commit/3de8702354

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit 26e55562ce449d407c95891c8d3258e15cc9b129
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 18:16:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    [ruby/json] Cleanup JSON.pretty_generate

    https://github.com/ruby/json/commit/01c47a0555

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit 2b9a9300ac4cb00824d59e59f6671a77cc003a1f
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 17:54:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 12:44:53 +0900

    [ruby/json] Deprecate `JSON.fast_generate`

    https://github.com/ruby/json/commit/6508455d82

  Notes:
    Merged: https://github.com/ruby/ruby/pull/13004

commit 589713bcb5cf4b52278a2cd6074d37c897dc79fc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-28 10:12:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 11:15:29 +0900

    Ignore to build C extension for test files of bundled gems

commit e652af18816ffe0b85109b8de0827349bf03f16d
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-28 01:29:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-28 07:24:52 +0900

    Update LEGAL to mention ext/json/vendor

    One file is under MIT, which is already the case of many files
    in Ruby, so it's fine.

    The other is under the Boost Software License, which is very
    similar to BSD and is fine to include in Ruby as far as I'm
    aware.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12998

commit 43683e1e9d8f7f6ed3fb4a48598190a0993f8f66
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-01-19 01:54:28 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2025-03-28 05:59:03 +0900

    Avoid allocation for anonymous positional splat with no arguments

    Anonymous positional splats cannot be directly accessed, they can
    only be passed as splats to other methods.  So if an anonymous
    positional splat would be empty, you can use a shared frozen
    empty array to save an allocation.

    ```ruby
    def a(*) end
    a()
    ```

    This is similar to how anonymous empty keyword splats are optimized,
    except those use `nil` instead of a shared empty frozen hash.

    This updates the allocation tests to check that the array allocations
    are avoided where possible.

    It also makes a small change to test_iseq.rb to ensure an unfrozen
    hash is passed as the value of an anonymous splat parameter.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12596

commit 72cb68972c878ca9a221bfffc6b6757807f8b2cf
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-03-28 05:38:35 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-28 05:39:38 +0900

    [ruby/etc] Attempt to re-enable TestEtc#test_ractor_parallel

    * If this fails, please revert this commit in ruby/etc
      to keep the repos sync'ed.

    https://github.com/ruby/etc/commit/87fb0c4a83

commit 0581947af536ec0fc3da295003455404e45b8f4d
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-03-28 05:38:00 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-28 05:39:38 +0900

    [ruby/etc] Speedup TestEtc#test_ractor_parallel

    https://github.com/ruby/etc/commit/18c12c084c

commit 2f1ac3fea377db64e8a7983ef25975418514d99a
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-03-28 05:20:02 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-28 05:21:21 +0900

    [ruby/etc] Increase timeout for test_ractor_parallel

    * It seems much slower on macOS (locally on Linux it's always < 1 second).

    https://github.com/ruby/etc/commit/9e46857011

commit d49483a747c7336f25019a6e4a4f81907309b361
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-28 03:14:25 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-28 05:14:36 +0900

    [ruby/prism] Move snapshots

    This is messing up the CRuby sync, so moving them out of the test
    directory will make this easier.

    https://github.com/ruby/prism/commit/7ba13bfb68

commit 67d1dd2ebd622c27d2ae0681c544d9f5d2f5349b
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-01-18 18:40:05 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2025-03-28 03:17:40 +0900

    Avoid array allocation for *nil, by not calling nil.to_a

    The following method call:

    ```ruby
    a(*nil)
    ```

    A method call such as `a(*nil)` previously allocated an array, because
    it calls `nil.to_a`, but I have determined this array allocation is
    unnecessary.  The instructions in this case are:

    ```
    0000 putself                                                          (   1)[Li]
    0001 putnil
    0002 splatarray                             false
    0004 opt_send_without_block                 <calldata!mid:a, argc:1, ARGS_SPLAT|FCALL>
    0006 leave
    ```

    The method call uses `ARGS_SPLAT` without `ARGS_SPLAT_MUT`, so the
    returned array doesn't need to be mutable.  I believe all cases where
    `splatarray false` are used allow the returned object to be frozen,
    since the `false` means to not duplicate the array.  The optimization
    in this case is to have `splatarray false` push a shared empty frozen
    array, instead of calling `nil.to_a` to return a newly allocated array.

    There is a slightly backwards incompatibility with this optimization,
    in that `nil.to_a` is not called.  However, I believe the new behavior
    of `*nil` not calling `nil.to_a` is more consistent with how `**nil`
    does not call `nil.to_hash`.  Also, so much Ruby code would break if
    `nil.to_a` returned something different from the empty hash, that it's
    difficult to imagine anyone actually doing that in real code, though
    we have a few tests/specs for that.

    I think it would be bad for consistency if `*nil` called `nil.to_a`
    in some cases and not others, so this changes other cases to not
    call `nil.to_a`:

    For `[*nil]`, this uses `splatarray true`, which now allocates a
    new array for a `nil` argument without calling `nil.to_a`.

    For `[1, *nil]`, this uses `concattoarray`, which now returns
    the first array if the second array is `nil`.

    This updates the allocation tests to check that the array allocations
    are avoided where possible.

    Implements [Feature #21047]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12597

commit 6ecfe643b5d8d64682c6f6bce5b27db5c007331d
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-03-24 20:17:58 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-28 01:54:56 +0900

    Freeze $/ and make it ractor safe

    [Feature #21109]

    By always freezing when setting the global rb_rs variable, we can ensure
    it is not modified and can be accessed from a ractor.

    We're also making sure it's an instance of String and does not have any
    instance variables.

    Of course, if $/ is changed at runtime, it may cause surprising behavior
    but doing so is deprecated already anyway.

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12975

commit 49d49d5985fa22d6f283e1f0e5299d18dd94e77d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-27 23:47:13 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-27 23:56:49 +0900

    [ruby/psych] Format Date in ISO-8601 explicitly

    Fix https://github.com/ruby/psych/pull/644

    https://github.com/ruby/psych/commit/b1ade765ba

commit 5adb2591dacc9b9c40db373616b6bc0b5c5dadb7
  Author:     Naoto Ono <onoto1998@gmail.com>
  AuthorDate: 2025-03-27 21:22:38 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-27 21:22:38 +0900

    Skip TestThreadInstrumentation#test_sleeping_inside_ractor on ModGC workflow (#12996)

    TestThreadInstrumentation#test_sleeping_inside_ractor is a flaky and failing intermittently. Additionally, Launchable reported this test as a top flaky test. (Link: https://app.launchableinc.com/organizations/ruby/workspaces/ruby/insights/unhealthy-tests)

    It failed only failed intermittently on ModGC workflow, so I'm gonna skip this test on ModGC workflow.

  Notes:
    Merged-By: ono-max <onoto1998@gmail.com>

commit c577416b27337e94df2db38c0a7925994188ac07
  Author:     Andrew Konchin <andry.konchin@gmail.com>
  AuthorDate: 2025-03-27 07:25:15 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-03-27 19:09:24 +0900

    Do not run ruby/spec on CI on Ruby 3.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12984

commit bac22c985ecc7e4309b5b5e5ae1074c81319e889
  Author:     Andrew Konchin <andry.konchin@gmail.com>
  AuthorDate: 2025-03-27 02:56:40 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-03-27 19:09:24 +0900

    Update to ruby/spec@5e579e2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12984

commit 53a930f1570c81d2f7829f932e8d7ad67e8462b8
  Author:     Andrew Konchin <andry.konchin@gmail.com>
  AuthorDate: 2025-03-27 02:56:35 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-03-27 19:09:24 +0900

    Update to ruby/mspec@484310d

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12984

commit df08cc629e36dace0cc0be8cb7b67ff6e505a711
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-27 15:13:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 16:57:10 +0900

    [rubygems/rubygems] Bump up connection_pool-2.5.0 with rake vendor:install

    https://github.com/rubygems/rubygems/commit/33c3caa63f

commit 62a026a425560f534d6e99bd2f3adf90ff6f101b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-27 15:05:44 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 16:57:10 +0900

    [rubygems/rubygems] Fix Style/RedundantParentheses by bin/rubocop -a

    https://github.com/rubygems/rubygems/commit/4bbf02493e

commit c9e07da51d9780cb4bb4c670938675b2fad65e34
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-27 15:04:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 16:57:10 +0900

    [rubygems/rubygems] Resolved Lint/ShadowingOuterLocalVariable warning

    https://github.com/rubygems/rubygems/commit/01a14a7073

commit d4a97ea313657b99716990b66649a367acac1321
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-27 16:54:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 16:56:59 +0900

    Update the all of gemfile deps

commit 752a1d785475d1950b33c7d77b289a6a3a753f02
  Author:     Hartley McGuire <skipkayhil@gmail.com>
  AuthorDate: 2025-03-26 12:27:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 13:57:26 +0900

    [rubygems/rubygems] Implement pub_grub strategy interface

    My application spends more than 30% of time during `bundle update`
    comparing versions due to versions being sorted inside
    next_package_to_try. This has been addressed in pub_grub by defining a
    strategy interface (a `#next_package_and_version` method) which allows
    consumers to have finer control over the heuristic to select the next
    package to try.

    This commit implements the new strategy interface to remove extraneous
    version sorting (previously in next_package_to_try) since only the final
    count of versions is used.

    Combined with a previous change to pub_grub (already applied to
    Bundler), this commit results in `bundle update` taking only half the
    time it did on 2.6.5.

    https://github.com/rubygems/rubygems/commit/62f69e27f0

commit af594f5166538d6d7f5c21d26ed824f03730c61a
  Author:     Ellen Marie Dash <me@duckie.co>
  AuthorDate: 2025-03-26 07:19:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 13:57:25 +0900

    [rubygems/rubygems] Have "gem exec" sort executable names in error message.

    This decouples `gem exec` behavior (and tests) from the sort order of
    the gemspec.

    https://github.com/rubygems/rubygems/commit/911cd29159

commit 9f17a0c7cb4cef10e462fec6a80691b55144853a
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-27 00:37:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 13:54:12 +0900

    Get rid of SAFE_STATE_PROTOTYPE

    It was only used by JRuby and TruffleRuby to call `SAFE_STATE_PROTOTYPE.dup`
    instead of `State.new` which isn't an worthy optimization.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12994

commit 4dde7101c722df3e1659ab0f4bee546afba9f3a5
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-25 18:59:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 13:54:12 +0900

    Refactor jeaiii-ltoa.h

    Some relatively minor change to make the library more in line
    with the gem. Some renaming, etc.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12994

commit 1b8e6568e41d1244b5e8a9f1f03348ec1a424863
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-03-27 11:56:33 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-03-27 12:28:28 +0900

    Pend a test for ractor in etc

    ... because it is flaky

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12992

commit c6f89e263e0a54114c4482fb9756b2ca081791d8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-27 11:01:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 11:37:27 +0900

    Skip failing rbs tests for removing deprecated methods

commit 6d82ea7db8f66ee148639f380013308f31d50e8e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-27 10:22:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 11:37:27 +0900

    Update ext/json/generator/depend

commit ee85745c616aa0dcd0bcf207708778a14c02816c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-27 10:12:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 11:37:27 +0900

    Removed trailing spaces

commit d1f3c8125854bb0976b08dbcbda3524d8ea3e3fe
  Author:     eno <eno@open-lab.org>
  AuthorDate: 2025-03-17 03:51:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 11:37:27 +0900

    Faster integer formatting

    This commit provides an alternative implementation for a
    long → decimal conversion.

    The main difference is that it uses an algorithm pulled from
    https://github.com/jeaiii/itoa.
    The source there is C++, it was converted by hand to C for
    inclusion with this gem.
    jeaiii's algorithm is covered by the MIT License, see source code.

    On addition this version now also generates the string directly into
    the fbuffer, foregoing the need to run a separate memory copy.

    As a result, I see a speedup of 32% on Apple Silicon M1 for an
    integer set of benchmarks.

commit dc6ffbbe9ec09c9786b67fb5a9427e5a963980a2
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-26 23:44:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 11:37:27 +0900

    [ruby/json] Remove unused `FAST_STATE_PROTOTYPE` and `PRETTY_STATE_PROTOTYPE`

    https://github.com/ruby/json/commit/18e5c3c67c

commit b71ec1196e6e50e47a96964f79b967914858e5e6
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-26 23:23:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 11:37:27 +0900

    [ruby/json] Remove `unparse` and `restore` aliases.

    These were deprecated 16 years ago.

    https://github.com/ruby/json/commit/a88d825a91

commit f4529ecbe7adf6cc24bf8f8aa92becbc005e897a
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-26 19:47:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-27 11:37:27 +0900

    [ruby/json] Deprecate all `*_default_options`

    Globally changing the behavior of the library is a bad idea, as
    many different libraries may rely on `json` and may not expect it
    and likely never tested that a different default config works for them.

    If you need to change the behavior of JSON, it's best to do it only
    locally, and not globally.

    In addition the new `JSON::Coder` interface is much more suited for
    that.

    Another reason for the deprecation is that it's impossible to
    make `JSON.load` and `JSON.dump` Ractor-safe with such API.

    https://github.com/ruby/json/commit/172762c6e4

commit 46ee73f4f6a6fceba4ed6dfe6622c78462a2b1ac
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-25 06:44:51 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-03-27 08:05:02 +0900

    Add additional Ractor.make_shareable tests

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12977

commit d80f3a287c5c8d0404b6cb837db360cab320cde1
  Author:     lukeg <luke.gru@gmail.com>
  AuthorDate: 2023-01-25 21:45:19 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-03-27 08:05:02 +0900

    Ractor.make_shareable(proc_obj) makes inner structure shareable

    Proc objects are now traversed like other objects when making them
    shareable.

    Fixes [Bug #19372]
    Fixes [Bug #19374]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12977

commit 2183899fd184ab1cfee80d57c0dd6f4dcd370375
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-25 22:37:46 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-26 22:35:51 +0900

    Re-use objspace variable instead of calling rb_gc_get_objspace()

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12979

commit 88f0c04174fe9aed88cfa6f8163c8a54e86b2117
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-26 18:24:39 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-26 19:37:22 +0900

    Use release version of turbo_tests

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12983

commit 310c00a1371ccbf584b7aaa4c1768a68c3813f58
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-26 06:34:41 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-03-26 11:14:26 +0900

    Reset thread interrupt lock on fork

    If a thread was holding this lock before fork, it will not exist in the
    child process. We should re-initialize these locks as we do with the VM
    locks when forking.

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12981

commit be6954f5d466f4b274505e4f14bcad291d0b0989
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-26 04:06:39 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-03-26 11:14:26 +0900

    Fail test if child process exists non-zero

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12981

commit 8f952a117870d2a3284a33988aa23e7af3a3a2d3
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-26 04:05:01 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-03-26 11:14:26 +0900

    Clear VM_CHECK lock info on fork

    We are resetting the actual lock so we should reset this information at
    the same time. Previously this caused an assertion to fail in debug
    mode.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12981

commit c576e83a241ef54b8da51e481676b286d905c120
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-03-26 07:16:31 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-26 07:16:31 +0900

    Prefer FL_TEST_RAW() in GC on known on-heap objects

    Was reading some assembly and noticed the dead branches generated for
    FL_TEST(). Just a quick basic pass to change the obvious places; there
    may be other opportunities.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12980

    Merged-By: XrXr

commit bfc5b8305d6a78b8cd011e89538dd7961d88dcff
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-03-26 06:20:59 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-26 06:27:16 +0900

    [ruby/etc] Etc.sysconfdir does not work in a Ractor

    * Because it uses RbConfig::CONFIG.
    * See https://github.com/ruby/ruby/actions/runs/14069312270/job/39399502142#step:12:947

    https://github.com/ruby/etc/commit/12dbe03b6a

commit 6bb35a1de4f6c769171a57dc5d832b5f2217d0c6
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-24 00:45:45 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-26 05:19:32 +0900

    Make ruby_autocompact_compare_func static

    It's not used outside of default.c.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12964

commit e4c7eb1152968fd9054d074cd5656c6bb896bab4
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-24 00:45:27 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-26 05:19:32 +0900

    Make ruby_enable_autocompact static

    It's not used outside of defaut.c

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12964

commit b9e9a1034a9530c8e3db83239224fb70e464e509
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-02-20 01:46:07 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-26 05:17:01 +0900

    [ruby/etc] Most Etc methods are not Ractor-safe currently

    * See https://bugs.ruby-lang.org/issues/21115

    https://github.com/ruby/etc/commit/ae62b7619c

commit 0b186ed4133c0825047d97341788f77c1dc4df11
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-26 04:26:51 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-26 04:26:51 +0900

    [DOC] Doc for Hash#transform_keys! (#12942)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit eb3f73ae9c777f233af950c4779a0fb553a2c565
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-24 23:55:23 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-25 21:49:31 +0900

    [DOC] Use install-modular-gc in gc/README.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12976

commit 1427629a5ff6e74518d25447ad19ce45c8338032
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-20 04:39:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-25 10:36:33 +0900

    [rubygems/rubygems] Remove specs with bad sources when converging dependencies

    https://github.com/rubygems/rubygems/commit/a0f7851451

commit fd43aca13b004b978103a836a7caad2a6fa6bba0
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-20 23:37:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-25 10:36:33 +0900

    [rubygems/rubygems] Tweak to check specs size just once

    https://github.com/rubygems/rubygems/commit/4497555023

commit 2eb5690ab6f8ca273e1bcb3dc064ff9a946cb0d0
  Author:     Randy Stauner <randy.stauner@shopify.com>
  AuthorDate: 2025-03-13 06:14:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-25 10:36:32 +0900

    [rubygems/rubygems] Add test for fixing mismatched versions in lockfile

    This test confirms that a bug that existed in 2.6.3
    was fixed by https://github.com/rubygems/rubygems/commit/b8e55087f026

    https://github.com/rubygems/rubygems/commit/9e4ca5c5b2

commit 319fcca656447ad969ff61868eea4356358c53db
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-24 02:48:23 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-24 21:49:30 +0900

    Move rb_gc_impl_ractor_cache_free to shutdown section

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12965

commit a572ec1ba0830ce812e8359aec20835bcbb209be
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-24 02:47:56 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-24 21:49:30 +0900

    Move rb_gc_impl_objspace_free to shutdown section

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12965

commit 56b89d31c722f31164174ea5eb3aa5ec12754d73
  Author:     Naoto Ono <onoto1998@gmail.com>
  AuthorDate: 2025-03-24 20:45:24 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-24 20:45:24 +0900

    Launchable: Fix CI scripts by adding backslashes (#12974)

    The following command doesn't work correctly since a backslash doesn't exist after `exec`. This PR fixes it.

    ```
    if [ -n "${LAUNCHABLE_ORGANIZATION}" ]; then
      exec
      > >(tee launchable_stdout.log) \
      2> >(tee launchable_stderr.log)
    fi
    ```

  Notes:
    Merged-By: ono-max <onoto1998@gmail.com>

commit 42daa6c2a2b49b4e45f40736e25c7d182860f24a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-24 15:49:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-24 15:49:41 +0900

    [Bug #21141] [DOC] Fix indentation

commit 51bc992822f9108ad64de32d300e1cefd0e2da59
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-24 15:43:40 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-24 15:43:40 +0900

    [Bug #21141] [DOC] Refine description of `Time#utc?`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12972

commit c5f30e9567af587f91676cb49eacf3fe70146811
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-24 15:24:47 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 15:24:47 +0900

    Update ext/json/generator/depend

commit 6b15857e2563cec0b38e6bce7646c1a9abaf4ba3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-24 15:20:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 15:20:59 +0900

    Removed trailing space

commit f3f4524d19476447df390ce9960778eac973b79b
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-20 19:05:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 14:49:44 +0900

    Reorganize `fpconv` vendoring

    Make it a single file and declare the dependency.

commit c98e6a9b8959f4a564eb71024d0f91e1f2f84352
  Author:     eno <eno@open-lab.org>
  AuthorDate: 2025-03-20 18:05:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 14:35:05 +0900

    [ruby/json] Extends license description

    https://github.com/ruby/json/commit/cce3d1f6c1

commit 528c08cc5fe8f8c990442885c0a30c95d8798e55
  Author:     eno <eno@open-lab.org>
  AuthorDate: 2025-03-20 06:48:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 14:35:04 +0900

    [ruby/json] Adjust fpconv to add ".0" to integers

    Adds a test case

    fix

    https://github.com/ruby/json/commit/fa5bdf87cb

commit a59333c58bbe0df0baaada6d3cc4a64b0aaf911e
  Author:     eno <eno@open-lab.org>
  AuthorDate: 2025-03-17 04:28:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 14:35:04 +0900

    [ruby/json] Faster float formatting

    This commit provides an alternative implementation for a float → decimal conversion.

    It integrates a C implementation of Fabian Loitsch's Grisu-algorithm [[pdf]](http://florian.loitsch.com/publications/dtoa-pldi2010.pdf), extracted from https://github.com/night-shift/fpconv. The relevant files are added in this PR, they are, as is all of https://github.com/night-shift/fpconv, available under a MIT License.

    As a result, I see a speedup of 900% on Apple Silicon M1 for a float set of benchmarks.

    floats don't have a single correct  string representation: a float like `1000.0` can be represented as "1000", "1e3", "1000.0" (and more).

    The Grisu algorithm converts floating point numbers to an optimal decimal string representation without loss of precision. As a result, a float that is exactly an integer (like `Float(10)`) will be converted by that algorithm into `"10"`. While technically correct – the JSON format treats floats and integers identically –, this differs from the current behaviour of the `"json"` gem. To address this, the integration checks for that case, and explicitely adds a ".0" suffix in those cases.

    This is sufficient to meet all existing tests; there is, however, a chance that the current implementation and this implementation occasionally encode floats differently.

    ```
    == Encoding floats (4179311 bytes)
    ruby 3.4.1 (2024-12-25 revision https://github.com/ruby/json/commit/48d4efcb85) +YJIT +PRISM [arm64-darwin24]
    Warming up --------------------------------------
            json (local)     4.000 i/100ms
    Calculating -------------------------------------
            json (local)     46.046 (± 2.2%) i/s   (21.72 ms/i) -    232.000 in   5.039611s

    Normalize to 2090234 byte
    == Encoding floats (4179242 bytes)
    ruby 3.4.1 (2024-12-25 revision https://github.com/ruby/json/commit/48d4efcb85) +YJIT +PRISM [arm64-darwin24]
    Warming up --------------------------------------
           json (2.10.2)     1.000 i/100ms
    Calculating -------------------------------------
           json (2.10.2)      4.614 (± 0.0%) i/s  (216.74 ms/i) -     24.000 in   5.201871s
    ```

    These benchmarks are run via a script ([link](https://gist.github.com/radiospiel/04019402726a28b31616df3d0c17bd1c)) which is based on the gem's `benchmark/encoder.rb` file. There are probably better ways to run benchmarks :) My version allows to combine multiple test cases into a single one.

    The `dumps` benchmark, which covers the JSON files in `benchmark/data/*.json` – with the exception of `canada.json` – , reported a minor speedup within statistical uncertainty.

    https://github.com/ruby/json/commit/7d77415108

commit ef7c7f9e77777477b8f6cdd72f92f9650afafdb4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-24 10:46:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    Revert "Fix broken CI. (#12963)"

    This reverts commit eb91c664dc0b4d69db09ae913f2d7a5ef3490d74.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 55930987e10b84a39562cdbd483f9d85074d26fe
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-13 03:19:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Raise an error in frozen mode if CHECKSUMS entries are missing

    https://github.com/rubygems/rubygems/commit/054a0cd76c

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 60d00da083a8006fbd6e903d7c844ac632b59ec7
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-17 23:27:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Fix redundant `path` configurations

    The deployment setting already does this implicitly.

    https://github.com/rubygems/rubygems/commit/402b11fa39

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 131559f6715cc2c0f7d681a6fd71a979e91500dd
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-15 02:34:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Rename block variable

    It's a dependency, not a specification.

    https://github.com/rubygems/rubygems/commit/9d78f5aa14

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 9c1be12f99af34924c90f6848903480246f07365
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-13 03:02:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Add `Specification#lock_name` and use that when dealing with checksums

    https://github.com/rubygems/rubygems/commit/8e2c5748d9

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 5bff692346bda9f282acbe4236dc7ddabc0b90be
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-17 21:04:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Refactor replacing locked specification path sources

    Instead of doing an explicit pass, let sources be replaced while checking
    if specifications are up to date.

    https://github.com/rubygems/rubygems/commit/676271e804

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 28943c2820b8f620b98a951c0ae1f821b0880a8e
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-17 21:03:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Refactor replacement of locked path sources

    Instead of doing an explicit pass to preserve the source from the
    Gemfile when it's a `Source::Gemspec`, add a special case to our generic
    source replacement method.

    https://github.com/rubygems/rubygems/commit/20c8c42380

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 164952cef3929035ff0d83b2432942b15118493d
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-17 20:51:47 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Remove unnecessary replacement of locked dependencies sources

    The `converge_dependencies` method already replaces the source of the
    dependency with an equivalent source from the Gemfile if possible.

    https://github.com/rubygems/rubygems/commit/a449e7ba19

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 20f57c5dc1a4b4169e749d86e4f1fa1022951c9a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-15 04:20:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Refactor Path vs Gemspec source comparison

    https://github.com/rubygems/rubygems/commit/58e9bd9962

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 765da72839ba6b228656148389f84e4c89e1b629
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-14 03:09:39 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Refactor replacing sources

    https://github.com/rubygems/rubygems/commit/4c05ac8306

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 192e57db31911af68e0033c59b0c58139ef237d6
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-14 03:00:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Remove `spec.source` duplication

    https://github.com/rubygems/rubygems/commit/24523a839e

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 000f01977204ba677a4208a6682d12d2f1375e5d
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-14 02:57:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Simplify passing "gemspec" option to path sources

    https://github.com/rubygems/rubygems/commit/9c6b57c01d

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit c55cc01b1e2feb707c90ad8e9d62a2c5572d79ed
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-14 02:16:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Remove unused default value

    https://github.com/rubygems/rubygems/commit/e9f4d1e5c2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 58663e8e2c1d787ef308029b2138e9b66c616714
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-11 01:09:33 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Change behavior when gemfile and gemspec dep deps conflict

    https://github.com/rubygems/rubygems/commit/7026b5f2e5

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 504b4bd9f5b3dda38f3b747e549b281719996078
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-11 01:08:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Use `name` argument consistently

    https://github.com/rubygems/rubygems/commit/4e66fe4208

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 3b78b888423f85e206f70909adaed9ecb5dfe900
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-21 02:19:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Support git 2.49

    One error message that we parse is now slightly different.

    https://github.com/rubygems/rubygems/commit/758528791d

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 6982b80a8bf236271de246adab1d9fca07cbb39c
  Author:     Ellen Marie Dash <me@duckie.co>
  AuthorDate: 2025-03-14 06:08:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Default to a SOURCE_DATE_EPOCH of 315619200, to simplify reproducible builds.

    https://github.com/rubygems/rubygems/commit/1d5a627398

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 4fe882e2c925c067693fbd432228d92548481ec4
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-18 04:10:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Let `gem exec` raise an error in ambiguous cases

    When `gem exec foo` is run, and "foo" is a gem that has multiple
    executables, none of them named "foo", raise an error explaining the
    situation and telling user to be more specific.

    Currently the first command in the executables array is run, but this
    may come as surprising sometimes, so better raise an error.

    https://github.com/rubygems/rubygems/commit/acda5d8f6e

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit ee7cfb1d1ec25f38c14e5d3cec72ed87937ef1c4
  Author:     Hartley McGuire <skipkayhil@gmail.com>
  AuthorDate: 2025-03-18 06:22:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Update vendored pub_grub

    https://github.com/rubygems/rubygems/commit/3aaa75e7b9

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit afda30774c8165428ca886945889c8747c66e599
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-13 03:26:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Reword log message about current platform being missing

    It reads better this way I think.

    https://github.com/rubygems/rubygems/commit/ce9743290d

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 4e1df25b158f35d0aef09ce6e6fd278392cc8230
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-13 02:38:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Improve grammar of some error messages

    https://github.com/rubygems/rubygems/commit/558a4765c7

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit bb1b5877a7b2dba79c81275f32b7cc5485323540
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-13 02:16:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Consistently use "lockfile" over "lock file"

    https://github.com/rubygems/rubygems/commit/e891be9197

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 33201adf686044163951de3068ca915fd6cea6cd
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-13 02:15:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:25:07 +0900

    [rubygems/rubygems] Fix frozen error message incorrectly mentioning the Gemfile

    It meant to mention the lockfile here.

    https://github.com/rubygems/rubygems/commit/2f0233a0fb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12968

commit 4b1fea81f93af5a0c8df6a1de6026fe480b5f534
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-24 02:47:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-24 07:16:45 +0900

    [ruby/prism] Update Ruby deps

    https://github.com/ruby/prism/commit/594e2a69ed

commit 12b2b577b7737ed4e81ca89b851fb429194c95fc
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-24 00:09:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-24 00:09:08 +0900

    [DOC] Doc for Hash#transform_values!

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12944

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 383af53a56f7e4a490b891701f96f91ef31e0bef
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-17 06:07:11 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-24 00:07:31 +0900

    [DOC] Doc for Hash#transform_values

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12943

commit 7e0dac4cb18be87600068c346cd5339d1d880f01
  Author:     Mohamed Hafez <mohamed.m.m.hafez@gmail.com>
  AuthorDate: 2025-03-23 19:45:23 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-23 19:45:23 +0900

    Add test for Ractor safety (#11762)

  Notes:
    Merged-By: eregon <eregontp@gmail.com>

commit 5f77f9bea61fb4cc8447a76e191fdfb28f076862
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-03-23 09:42:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-23 09:42:04 +0900

    Fix handling of `error`/`errno` in `io_internal_wait`. (#12961)

    [Bug #21195]

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit eb91c664dc0b4d69db09ae913f2d7a5ef3490d74
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-03-23 08:49:18 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-23 08:49:18 +0900

    Fix broken CI. (#12963)

    * Increase timeout to fix flaky tests?

    * Fix bundler test - wording changed.

    expect "fatal: Remote branch deadbeef not found in upstream origin" to
    include "Revision deadbeef does not exist in the repository"

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit c49051eaa82e68b1a8792ad79f8cf2cf73f5ee90
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-20 23:52:26 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-23 02:08:42 +0900

    [ruby/prism] Enforce a minimum `parser` version for the parser translator

    There hasn't been much that would actually affect parsers usage of it.
    But, when adding new node types, these usually appear in the `Parser::Meta::NODE_TYPES`.

    `itblock` was added, gets emitted by prism, and then `rubocop-ast` blindly delegates to `on_itblock`.
    These methods are dynamically created through `NODE_TYPES`, which means that it will error if it
    doesn't contain `itblock`.

    This is unfortunate because in `rubocop-ast` these methods are eagerly defined but
    the prism translator is lazily loaded on demand.
    The simplest solution is to add them on the `parser` side (even if they are not emitted directly), and require that a version that contains those be used.

    In summary when adding a new node type:
    * Add it to `Parser::Meta::PRISM_TRANSLATION_PARSER_NODE_TYPES` (gets included in `NODE_TYPES`)
    * Bump the minimum `parser` version used by `prism` to a version that contains the above change
    * Actually emit that node type in `prism`

    https://github.com/ruby/prism/commit/d73783d065

commit 13e6f715ef766eb04ba6862d1d716eb03fea6396
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-03-22 18:50:36 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-23 02:06:46 +0900

    [ruby/prism] Include nodeId in Java Node only if necessary

    * See https://github.com/ruby/prism/issues/3502

    https://github.com/ruby/prism/commit/b7aedfe696

commit 595040ba271175e18c8461a926c34903742788de
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-03-22 01:19:42 +0900
  Commit:     Aaron Patterson <tenderlove@ruby-lang.org>
  CommitDate: 2025-03-22 04:25:02 +0900

    FCALL shouldn't be forwarded from caller

    When we forward an FCALL (a method call with an implicit self), we
    shouldn't forward the FCALL flag because it ignores method visibility
    checks.  This patch removes the FCALL flag from callers.

    [Bug #21196]

commit 93ac342afc5e42c0361c8fccf378ca14b2e8b0dd
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-21 23:12:09 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-21 23:18:57 +0900

    [ruby/prism] Add node_id to Java serialization

    https://github.com/ruby/prism/commit/93e768bd18

commit 9b5165b1d7b197befa01327f5aef2ecebed2914e
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-21 17:00:44 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-21 20:18:33 +0900

    [ruby/prism] Don't use `RUBY_VERSION.to_f`

    There will be a bunch of other problems should 3.10 ever exists, but I guess why not fix this one now.

    https://github.com/ruby/prism/commit/b385f47f8b

commit d868922ea8e68dc2292e351c8266ef3c3058bf1e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-21 15:17:15 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-21 15:17:15 +0900

    Fix regexp when non-ruby thread received the signal

    A space is added only when the source path is found.

commit edabdd95a84a31c61bab651584d58fe7f695552a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-21 11:05:57 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-21 11:05:57 +0900

    Run cleanup code in `ensure`

commit 99503ab9751c09a2f5467dee4ceb0e30af4e95bd
  Author:     Joshua Young <djry1999@gmail.com>
  AuthorDate: 2025-03-20 17:44:10 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-21 10:36:13 +0900

    Escape `Binding` reference in pattern matching docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12955

commit 80ab42462e94025f69db38c9359c65d108ebb51b
  Author:     flavio-b <flaviobombonatti@gmail.com>
  AuthorDate: 2025-03-21 10:24:02 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-21 10:30:40 +0900

    [DOC] beginless and endless ranges inspect returns "nil..nil" always

    Small correction to the Range docs. All beginless (nil..) and endless (..nil) ranges, as well as fully open ranges (nil..nil), display "nil..nil" when inspected, regardless of their original syntax.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12959

commit 65bc0ec62dee1e3210f5ce4e824f818beb718bcd
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-03-21 05:19:22 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-21 06:24:19 +0900

    [ruby/prism] Fix fork check in ractor_test.rb

    https://github.com/ruby/prism/commit/0073266cad

commit e47078fb306bc6ec07b01df8d0c811c43ff6e0ae
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-21 01:38:11 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-21 06:23:36 +0900

    [ruby/prism] Update ractor_test.rb per review

    https://github.com/ruby/prism/commit/fd96a6821f

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12958

commit ab8b199be82c3191723067867c4f078dee94df89
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-21 06:00:28 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-21 06:20:23 +0900

    [ruby/prism] Add `Prism::Translation::ParserCurrent`

    It's not my favorite api but for users that currently use the same thing
    from `parser`, moving over is more difficult
    than it needs to be.

    If you plan to support both old and new ruby versions, you definitly need to
    branch somewhere on the ruby version
    to either choose prism or parser.
    But with prism you then need to enumerate all the versions again and choose the correct one.

    Also, don't recommend to use `Prism::Translation::Parser` in docs. It's version-less
    but actually always just uses Ruby 3.4 which is probably
    not what the user intended.

    Note: parser also warns when the patch version doesn't match what it expects. But I don't think prism has such a concept,
    and anyways it would require releases anytime ruby releases, which I don't think is very desirable

    https://github.com/ruby/prism/commit/77177f9e92

commit bfe6068417ca41a6b88a1ba5fcde04f9a76718a7
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-19 07:02:44 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-03-21 05:09:40 +0900

    Use atomic for method reference count [Bug #20934]

    This changes reference_count on rb_method_definition_struct into an
    atomic.

    Ractors can create additional references as part of `bind_call` or
    (presumably) similar. Because this can be done inside Ractors, we should
    use a lock or atomics so that we don't race and avoid incrementing.

    Co-authored-by: wanabe <s.wanabe@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12951

commit 62cc3464d902ee7a399ec8c38606fdc0ee98f05e
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-03-21 01:48:34 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2025-03-21 03:49:13 +0900

    Remove leading `nop` from block when we don't need it

    Blocks insert a leading `nop` instruction in order to execute a "block
    call" tracepoint. Block compilation unconditionally inserts a leading
    `nop` plus a label after the instruction:

      https://github.com/ruby/ruby/blob/641f15b1c6bd8921407a1f045573d3b0605f00d3/prism_compile.c#L6867-L6869

    This `nop` instruction is used entirely for firing the block entry
    tracepoint.  The label exists so that the block can contain a loop but
    the block entry tracepoint is executed only once.

    For example, the following code is an infinite loop, but should only
    execute the b_call tracepoint once:

    ```ruby
    -> { redo }.call
    ```

    Previous to this commit, we would eliminate the `nop` instruction, but
    only if there were no other jump instructions inside the block.  This
    means that the following code would still contain a leading `nop` even
    though the label following the `nop` is unused:

    ```ruby
    -> { nil if bar }
    ```

    ```
    == disasm: #<ISeq:block in <main>@test.rb:1 (1,2)-(1,17)> (catch: FALSE)
    0000 nop                                                              (   1)[Bc]
    0001 putself                                [Li]
    0002 opt_send_without_block                 <calldata!mid:bar, argc:0, FCALL|VCALL|ARGS_SIMPLE>
    0004 branchunless                           8
    0006 putnil
    0007 leave                                  [Br]
    0008 putnil
    0009 leave                                  [Br]
    ```

    This commit checks to see if the label inserted after the `nop` is
    actually a jump target.  If it's not a jump target, then we should be
    safe to eliminate the leading `nop`:

    ```
    > build-master/miniruby --dump=insns test.rb
    == disasm: #<ISeq:<main>@test.rb:1 (1,0)-(1,17)>
    0000 putspecialobject                       1                         (   1)[Li]
    0002 send                                   <calldata!mid:lambda, argc:0, FCALL>, block in <main>
    0005 leave

    == disasm: #<ISeq:block in <main>@test.rb:1 (1,2)-(1,17)>
    0000 putself                                                          (   1)[LiBc]
    0001 opt_send_without_block                 <calldata!mid:bar, argc:0, FCALL|VCALL|ARGS_SIMPLE>
    0003 branchunless                           7
    0005 putnil
    0006 leave                                  [Br]
    0007 putnil
    0008 leave                                  [Br]
    ```

    We have a test for b_call tracepoints that use `redo` here:

      https://github.com/ruby/ruby/blob/aebf96f371c8d874398e0041b798892e545fa206/test/ruby/test_settracefunc.rb#L1728-L1736

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12957

commit f07af59a2f10beeb99878c967cefed2912310030
  Author:     Sam Bostock <sam.bostock@shopify.com>
  AuthorDate: 2025-03-12 00:11:26 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-21 02:28:59 +0900

    [ruby/prism] Dynamically register events to dispatch

    Instead of requiring the consumer to provide a list of all events which
    they wish to handle, we can give them to option of dynamically detecting
    them, by scanning the listener's public methods.

    This approach is similar to that used by Minitest (scanning for `test_`
    methods) and Rails generators (running all public methods in the order
    they are defined).

    While this is slower than specifying a hard coded list, the penalty is
    only during registration. There is no change the the behaviour of
    dispatching the events.

    https://github.com/ruby/prism/commit/781ebed743

commit de097fbe5f3df105bd2a26e72db06b0f5139bc1a
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-21 01:25:15 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-21 02:18:11 +0900

    Trigger `inherited` and `const_set` callbacks after const has been defined

    [Misc #21143]
    [Bug #21193]

    The previous change caused a backward compatibility issue with code
    that called `Object.const_source_location` from the `inherited` callback.

    To fix this, the order is now:

    - Define the constant
    - Invoke `inherited`
    - Invoke `const_set`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12956

commit a51364f54b644ba2d98779f0af8c7203822d9a31
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-20 20:59:42 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-20 20:59:42 +0900

    Close reader pipes

commit 820c541671d9485144d81138bb029f2da8379edd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-13 15:17:26 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-20 17:32:26 +0900

    [Bug #21026] no singleton method on pseudo variable literal

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12925

commit 641f15b1c6bd8921407a1f045573d3b0605f00d3
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-20 05:50:41 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-20 06:11:57 +0900

    [ruby/prism] Mark Prism as ractor-safe

    https://github.com/ruby/prism/commit/c02429765b

commit 050ffab82b1a855d6b6edf5fbc6dc8c9311b6556
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-20 03:54:12 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-20 06:03:18 +0900

    [ruby/prism] Polyfill Kernel#warn category parameter

    https://github.com/ruby/prism/commit/d85c72a1b9

commit b5e9a2da4c668fe73f9fcca2b237def56c507464
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-20 00:41:49 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-20 06:03:17 +0900

    [ruby/prism] Remove `category` keyword from `warn` call

    `category` is only supported from Ruby 3.0 onwards and prism can still run with Ruyb 2.7

    https://github.com/ruby/prism/commit/335a193851

commit e5e160475bbd94ab90525132f7987cf29e9afc11
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-20 00:40:58 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-20 06:03:17 +0900

    [ruby/prism] Warn when the parser translator receives an incompatible builder class

    In https://github.com/ruby/prism/pull/3494 I added a bit of code
    so that using the new builder doesn't break stuff.
    This code can be dropped when it is enforced that builder
    is _always_ the correct subclass (and makes future issues like that unlikely).

    https://github.com/ruby/prism/commit/193d4b806d

commit 265dcd1733ede8f3e4cb13322392d6c42b75700f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-19 16:57:11 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-19 17:00:01 +0900

    [ruby/optparse] bump up to 0.7.0.dev.2

    https://github.com/ruby/optparse/commit/8c2c7a4903

commit 6c7f721f1eaaba75c624b5a84d2c7ace30a96b2f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-19 15:08:20 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-19 15:08:20 +0900

    Source path may or may not exist

commit 3eb802fb562cbb29ec1ede64f6df70719fc8f144
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-03-19 14:57:15 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-03-19 14:57:15 +0900

    Loosen SEGV message testing

    Since `rb_bug` does not always take Ruby frame info during SEGV, the
    source file path may not be output.

    ```
      1) Failure:
    TestRubyOptions#test_crash_report_script [/tmp/ruby/src/trunk_gcc11/test/ruby/test_rubyoptions.rb:907]:
    Expected /
            bug\.rb:(?:1:)?\s\[BUG\]\sSegmentation\sfault.*\n
          /x
    to match
      "[BUG] Segmentation fault at 0x000003e900328766\n"+
    ```
    http://ci.rvm.jp/results/trunk_gcc11@ruby-sp2-noble-docker/5663880

commit 6e9568d202389dc5f820b024315cf8db0a5aae65
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-19 02:58:52 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-19 04:06:34 +0900

    [ruby/prism] Bump to v1.4.0

    https://github.com/ruby/prism/commit/71d31db496

commit adaaa7878ebee62888bf3547d14c1db4938da88a
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-19 02:40:49 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 03:44:28 +0900

    Handle void expressions in defined?

    [Bug #21029]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12949

commit b003d4019421e004460a8c947db2695d71ad0b8c
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-19 02:02:56 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    Fix up merge conflicts for prism sync

commit 33aaa069a4e7b405e6d7ec5fcbf04a487e36e345
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-18 23:51:45 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Update truffleruby version

    https://github.com/ruby/prism/commit/2afe89f8ce

commit 90d38ddb47f557b07b57c88139725267c7c313f8
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-02-26 01:06:16 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Fix merge mishap

    Caused by https://github.com/ruby/prism/pull/3478 and https://github.com/ruby/prism/pull/3443

    I also made the builder reference more explicit to clearly distinquish
    between `::Parser` and `Prism::Translation::Parser`

    https://github.com/ruby/prism/commit/d52aaa75b6

commit dc48c1aca347f43ef9cb122342c80d699c5860fa
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-14 02:59:45 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Add a multiple statements flag to parentheses

    This can get triggered even if the list of statements only contains
    a single statement. This is necessary to properly support compiling

    ```ruby
    defined? (;a)
    defined? (a;)
    ```

    as "expression". Previously these were parsed as statements lists
    with single statements in them.

    https://github.com/ruby/prism/commit/b63b5d67a9

commit e3c846463092da8a7533740f9960fd626c749305
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-21 00:01:19 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Only unnest parser mlhs nodes when no rest argument is provided

    ```
    (a,), = []

    PARSER====================
    s(:masgn,
      s(:mlhs,
        s(:mlhs,
          s(:lvasgn, :a))),
      s(:array))
    PRISM====================
    s(:masgn,
      s(:mlhs,
        s(:lvasgn, :a)),
      s(:array))
    ```

    https://github.com/ruby/prism/commit/8aa1f4690e

commit 94e12ffa39e46f5b1f80485e9b2e06a59cd69dac
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-19 23:54:07 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Fix parser translator multiline interpolated symbols

    In https://github.com/ruby/prism/commit/26370079291a420c6b2b7be5cdbd5c609da62f21 I added tests but didn't modify them correctly

    https://github.com/ruby/prism/commit/de021e74de

commit a8adf5e006da03b8ccaa2bf900f4f077ca9888cf
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-16 07:24:05 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Further refine string handling in the parser translator

    Mostly around newlines and line continuation.
    * percent arrays need special backslash handling in the ast
    * Fix offset issue for heredocs with many line continuations (used wrong variable as index access)
    * More refined rules on when to simplify string tokens
    * Handle line continuations in squiggly heredocs
    * Correctly dedent squiggly heredocs with interpolation
    * Consider `':foo:` and `%s[foo]` to not be interpolation

    https://github.com/ruby/prism/commit/4edfe9d981

commit fc14d3ac7d4fa14f568d2428b846f391ebdf0d62
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-17 16:53:35 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Allow to test a custom fixtures path during testing

    Of course, these won't really be fixtures, but it allows to test against whole codebases
    without copying them, doing symlinks or something like that.

    For example, I can tell that over the whole RuboCop codebase, there are only 8 files that produce mismatched ast.
    Telling what the problem is is a different problem. The ast for real files can and will be huge so I haven't checked yet
    (maybe parser bug) but it's nice for discoverability regardless

    https://github.com/ruby/prism/commit/2184d82ba6

commit 0b4604d5a0f999d7fdd33a9230587a775301a667
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-13 22:54:15 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Use Set.new over to_set

    https://github.com/ruby/prism/commit/422d5c4c64

commit ad478de3f0bbf3cf5a1e5e5f5cf01689717db4df
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-11 17:05:21 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Optimize array inclusion checks in the parser translator

    I see `Array.include?` as 2.4% runtime. Probably because of `LPAREN_CONVERSION_TOKEN_TYPES` but
    the others will be faster as well.

    Also remove some inline array checks. They are specifically optimized in Ruby since 3.4, but for now prism is for >= 2.7

    https://github.com/ruby/prism/commit/ca9500a3fc

commit d5503444fd6e680a85e9d0cf639dc9a27704ccc1
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-19 21:38:17 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Fix parser translator crash for certain octal escapes

    `Integer#chr` performs some validation that we don't want/need. Octal escapes can go above 255, where it will then raise trying to convert.

    `append_as_bytes` actually allows to pass a number, so we can just skip that call.
    Although, on older rubies of course we still need to handle this in the polyfill.
    I don't really like using `pack` but don't know of another way to do so.

    For the utf-8 escapes, this is not an issue. Invalid utf-8 in these is simply a syntax error.

    https://github.com/ruby/prism/commit/161c606b1f

commit 1944247a0e44521948076ac43e76df84b32a9204
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-01-17 04:16:30 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Handle control and meta escapes in parser translation

    https://github.com/ruby/prism/commit/09c59a3aa5

commit fd7a10cf4a73f27a0113a6bc2a65c4c274ee11ec
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-16 07:24:05 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Further refine string handling in the parser translator

    Mostly around newlines and line continuation.
    * percent arrays need special backslash handling in the ast
    * Fix offset issue for heredocs with many line continuations (used wrong variable as index access)
    * More refined rules on when to simplify string tokens
    * Handle line continuations in squiggly heredocs
    * Correctly dedent squiggly heredocs with interpolation
    * Consider `':foo:` and `%s[foo]` to not be interpolation

    https://github.com/ruby/prism/commit/4edfe9d981

commit 5d138f2b436dc84b1efed86ac3328e67638887cb
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-15 04:20:05 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Better handle regexp in the parser translator

    Turns out, it was already almost correct. If you disregard \c and \M style escapes, only a single character is allowed to be escaped in a regex so most tests passed already.

    There was also a mistake where the wrong value was constructed for the ast, this is now fixed.
    One test fails because of this, but I'm fairly sure it is because of a parser bug. For `/\“/`, the backslash is supposed to be removed because it is a multibyte character. But tbh,
    I don't entirely understand all the rules.

    Fixes more than half of the remaining ast differences for rubocop tests

    https://github.com/ruby/prism/commit/e1c75f304b

commit 177adf6fa543663334bfb8918b356b4771e5ff1a
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-14 05:17:29 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Fix parser translator tokens for %-arrays with whitespace escapes

    Also fixes a token incompatibility for the word separator. parser only considers whitespace until the first newline

    https://github.com/ruby/prism/commit/bd3dd2b62a

commit ac728389e219480dd678a01e6f91f96098d3b6d6
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-20 23:49:06 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Fix parser translator edge-case when multiline string ends with \n

    When the line contains no real newline but contains unescaped ones, then there will be one less entry

    https://github.com/ruby/prism/commit/4ef093b600

commit 0fcb7fc21d1923a61ffe4d127e6e72cc55560972
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-09 05:17:21 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Better handle all kinds of multiline strings in the parser translator

    This is a followup to #3373, where the implementation
    was extracted

    https://github.com/ruby/prism/commit/2637007929

commit acf404e20e3d7bc18cbb8abd2b16c62f9c1f996f
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2024-12-22 06:00:56 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Fix an incompatibility with the parser translator

    The offset cache contains an entry for each byte so it can't be accessed via the string length.

    Adds tests for all variants except for this:
    ```
    "fo
    o" "ba
    ’"
    ```

    For some reason, this still has the wrong offset.

    https://github.com/ruby/prism/commit/a651126458

commit f49a0114e36cbff434a442561b9637760665897b
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-21 02:38:08 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Fix parser translator rescue location with semicolon body

    There are a few other locations that should be included in that check.
    I think the end location must always be present but I left it in to be safe (maybe implicit begin somehow?)

    https://github.com/ruby/prism/commit/545d07ddc3

commit 12541d2cc0c550197d3b5b848315886149930519
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-01-16 11:30:21 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Track then keyword on rescue nodes

    https://github.com/ruby/prism/commit/bde8ccc038

commit a679597547b23259159dd914959ca36409878199
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-19 21:38:17 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Fix parser translator crash for certain octal escapes

    `Integer#chr` performs some validation that we don't want/need. Octal escapes can go above 255, where it will then raise trying to convert.

    `append_as_bytes` actually allows to pass a number, so we can just skip that call.
    Although, on older rubies of course we still need to handle this in the polyfill.
    I don't really like using `pack` but don't know of another way to do so.

    For the utf-8 escapes, this is not an issue. Invalid utf-8 in these is simply a syntax error.

    https://github.com/ruby/prism/commit/161c606b1f

commit bc506295a30a5806b3346ed09cd679f3b8ee6f64
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-16 07:24:05 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Further refine string handling in the parser translator

    Mostly around newlines and line continuation.
    * percent arrays need special backslash handling in the ast
    * Fix offset issue for heredocs with many line continuations (used wrong variable as index access)
    * More refined rules on when to simplify string tokens
    * Handle line continuations in squiggly heredocs
    * Correctly dedent squiggly heredocs with interpolation
    * Consider `':foo:` and `%s[foo]` to not be interpolation

    https://github.com/ruby/prism/commit/4edfe9d981

commit 9e5e3f1bede46ed499a809975c663ba32c34ffff
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-21 18:20:08 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Add a custom builder class for the parser translator

    I want to add new node types to the parser translator, for example `itblock`. The bulk of the work is already done by prism itself. In the `parser`
    builder, this would be a 5-line change at most but we don't control that here.

    Instead, we can add our own builder and either overwrite the few methods we need,
    or just inline the complete builder. I'm not sure yet which would be better.

    `rubocop-ast` uses its own builder for `parser`. For this to correctly work, it must explicitly choose to extend the
    prism builder and use it, same as it currently chooses to use a different parser when prism is used.

    I'd like to enforce that the builder for prism extends its custom one since it will lead to
    some pretty weird issues otherwise. But first, I'd like to change `rubocop-ast` to make use of this.

    https://github.com/ruby/prism/commit/b080e608a8

commit fcd6e536933514d222e28274a39ce92e96a575cd
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-19 00:52:13 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    Remove incorrectly committed snapshots

commit 705bd6fadbd5a784d2c0fd52138007404de6a5c2
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-13 04:08:28 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-03-19 02:36:53 +0900

    [ruby/prism] Fix parser translator when unescaping invalid utf8

    1. The string starts out as binary
    2. `ち` is appended, forcing it back into utf-8
    3. Some invalid byte sequences are tried to append

    > incompatible character encodings: UTF-8 and BINARY (ASCII-8BIT)

    This makes use of my wish to use `append_as_bytes`. Unfortunatly that method is rather new
    so it needs a fallback

    https://github.com/ruby/prism/commit/e31e94a775

commit 9c71b5901c700bb2b18b0083130e65e97e386089
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-01-22 18:30:08 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-19 01:28:59 +0900

    fix rb_w32_strerror when errno < 0

    change SystemCallError.new(-1) message on Windows

    (Bug #21083)
    https://bugs.ruby-lang.org/issues/21083

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12622

commit c717dbdc8198ddaedb6f7562cb74038fa2b30c6f
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-01-25 01:13:41 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-19 01:28:59 +0900

    avoid platform dependent message

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12622

commit f220866c39d12da8fffd9b41db8bf4b8dc80b74e
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-01-24 21:48:12 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-19 01:28:59 +0900

    Explicitly place a regular expression

    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12622

commit 0f6c647b1a1e313e3cb4fe79d4b63ffa2b7a6a6e
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-01-23 22:40:02 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-19 01:28:59 +0900

    avoid platform dependent message

    (Bug #21083)
    https://bugs.ruby-lang.org/issues/21083

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12622

commit 3d6fc2916907a351c274449280a82b020208f084
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-19 00:35:28 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-19 01:00:03 +0900

    [ruby/prism] Make xstrings concat syntax error

    https://github.com/ruby/prism/commit/f734350499

commit f69ad0e810e1fdc18dc12f77bbecfa49999ef3bf
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-01-29 16:55:44 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-18 23:47:20 +0900

    [Bug #21094] Update nested module names when setting temporary name

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12947

commit 6670926a91734ddb92d01ce4578b1bb48d26b7de
  Author:     Mari Imaizumi <mariimaizumi5@gmail.com>
  AuthorDate: 2025-02-24 12:09:26 +0900
  Commit:     Mari Imaizumi <mariimaizumi5@gmail.com>
  CommitDate: 2025-03-18 21:18:12 +0900

    Do not break within certain combinations with Indic_Conjunct_Break (InCB)=Linker.

    https://www.unicode.org/reports/tr29/tr29-43.html#GB9c

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12798

commit e63c516046b6dbf2f684454b68013b4eea12e94a
  Author:     Mari Imaizumi <mariimaizumi5@gmail.com>
  AuthorDate: 2025-02-24 12:01:14 +0900
  Commit:     Mari Imaizumi <mariimaizumi5@gmail.com>
  CommitDate: 2025-03-18 21:18:12 +0900

    [Feature #19908] Update Unicode headers to 15.1.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12798

commit 4f82a6f3e8d332926f9e3b615201d1b21a482f2f
  Author:     Mari Imaizumi <mariimaizumi5@gmail.com>
  AuthorDate: 2025-02-24 11:43:23 +0900
  Commit:     Mari Imaizumi <mariimaizumi5@gmail.com>
  CommitDate: 2025-03-18 21:18:12 +0900

    Support for Indic_Conjunct_Break in Unicode 15.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12798

commit 75844889eb0169fab62da3063c9bcc950be0ae88
  Author:     Mari Imaizumi <mariimaizumi5@gmail.com>
  AuthorDate: 2025-03-09 15:22:16 +0900
  Commit:     Mari Imaizumi <mariimaizumi5@gmail.com>
  CommitDate: 2025-03-18 21:04:02 +0900

    Fix case folding in single byte encoding

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12889

commit c7f31c88aeed45607d2abc6b641ad2ccfd77e240
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-18 17:55:46 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-18 17:55:46 +0900

    [Feature #20702] Tests for Array#fetch_values

commit 76aaf8ddf4b13411f925085046cee2422bb9902e
  Author:     Susan van den Broek <susan.van.den.broek@axini.com>
  AuthorDate: 2025-03-18 00:36:37 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-18 16:28:50 +0900

    [ruby/date] Add license files (COPYING, BSDL) to gem files

    https://github.com/ruby/date/commit/a3d85e0be5

commit 9b49ba5a68486e42afd83db49a48edf2bfc00105
  Author:     Hartley McGuire <skipkayhil@gmail.com>
  AuthorDate: 2025-03-13 05:01:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-18 09:42:38 +0900

    [rubygems/rubygems] Speed up Version#<=> ~20-50% when lengths differ

    Previously, the comparison code would loop through segments up to the
    longest of the two versions being compared. However, this is inefficient
    because once one version has more segments than the other we can do a
    lot less work.

    This commit optimizes the differing segment length case by specializing
    the logic once the iteration has passed the shorter of the two segment
    lengths. At this point we only need to continue looking at the longer
    version's segment, and we know that any String encountered means the
    version is less than (pre), and any non-zero Integer means the version
    is greater than.

    Benchmark:

    ```
    {
      first: [Gem::Version.new("1.2.3"), Gem::Version.new("2.2.3")],
      second: [Gem::Version.new("1.2.3"), Gem::Version.new("1.3.3")],
      third: [Gem::Version.new("1.2.3"), Gem::Version.new("1.2.4")],
      length: [Gem::Version.new("1.2.3"), Gem::Version.new("1.2.3.4")],
      left_s_second: [Gem::Version.new("1.a.3"), Gem::Version.new("1.2.3")],
      left_s_third: [Gem::Version.new("1.2.a"), Gem::Version.new("1.2.3")],
      right_s_second: [Gem::Version.new("1.2.3"), Gem::Version.new("1.a.3")],
      right_s_third: [Gem::Version.new("1.2.3"), Gem::Version.new("1.2.a")],
      left_s_length: [Gem::Version.new("8.0.1.pre"), Gem::Version.new("8.0.1")],
      right_s_length: [Gem::Version.new("8.0.1"), Gem::Version.new("8.0.1.pre")],
      both_s: [Gem::Version.new("8.0.2.pre1"), Gem::Version.new("8.0.2.pre2")],
    }.each do |name, v|
      puts "== #{name} =="

      raise name unless v[0].fast_comp(v[1]) == (v[0] <=> v[1])

      Benchmark.ips do |x|
        x.report("fast") { v[0].fast_comp(v[1]) }
        x.report("original") { v[0] <=> v[1] }
        x.compare!(order: :baseline)
      end
    end

    == first ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   208.555k i/100ms
                original   199.789k i/100ms
    Calculating -------------------------------------
                    fast      2.075M (± 6.0%) i/s  (481.93 ns/i) -     10.428M in   5.055818s
                original      2.045M (± 3.9%) i/s  (488.94 ns/i) -     10.389M in   5.090034s

    Comparison:
                    fast:  2075002.8 i/s
                original:  2045227.4 i/s - same-ish: difference falls within error

    == second ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   192.395k i/100ms
                original   183.000k i/100ms
    Calculating -------------------------------------
                    fast      1.892M (± 3.8%) i/s  (528.62 ns/i) -      9.620M in   5.094104s
                original      1.824M (± 3.5%) i/s  (548.11 ns/i) -      9.150M in   5.023163s

    Comparison:
                    fast:  1891722.2 i/s
                original:  1824435.3 i/s - same-ish: difference falls within error

    == third ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   172.788k i/100ms
                original   162.934k i/100ms
    Calculating -------------------------------------
                    fast      1.719M (± 9.0%) i/s  (581.72 ns/i) -      8.467M in   5.025861s
                original      1.638M (± 3.6%) i/s  (610.36 ns/i) -      8.310M in   5.080344s

    Comparison:
                    fast:  1719042.9 i/s
                original:  1638389.6 i/s - same-ish: difference falls within error

    == length ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   191.741k i/100ms
                original   155.952k i/100ms
    Calculating -------------------------------------
                    fast      1.920M (± 3.9%) i/s  (520.74 ns/i) -      9.587M in   5.002328s
                original      1.576M (± 6.2%) i/s  (634.42 ns/i) -      7.954M in   5.072507s

    Comparison:
                    fast:  1920362.1 i/s
                original:  1576240.9 i/s - 1.22x  slower

    == left_s_second ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   176.441k i/100ms
                original   164.879k i/100ms
    Calculating -------------------------------------
                    fast      1.609M (± 7.3%) i/s  (621.51 ns/i) -      8.116M in   5.083414s
                original      1.620M (± 8.3%) i/s  (617.43 ns/i) -      8.079M in   5.028525s

    Comparison:
                    fast:  1608994.8 i/s
                original:  1619606.5 i/s - same-ish: difference falls within error

    == left_s_third ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   160.562k i/100ms
                original   152.799k i/100ms
    Calculating -------------------------------------
                    fast      1.591M (± 3.6%) i/s  (628.40 ns/i) -      8.028M in   5.052029s
                original      1.528M (± 3.6%) i/s  (654.31 ns/i) -      7.640M in   5.007526s

    Comparison:
                    fast:  1591334.1 i/s
                original:  1528320.6 i/s - same-ish: difference falls within error

    == right_s_second ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   135.938k i/100ms
                original   132.907k i/100ms
    Calculating -------------------------------------
                    fast      1.367M (± 1.2%) i/s  (731.77 ns/i) -      6.933M in   5.074030s
                original      1.320M (± 2.4%) i/s  (757.35 ns/i) -      6.645M in   5.036155s

    Comparison:
                    fast:  1366548.7 i/s
                original:  1320386.4 i/s - same-ish: difference falls within error

    == right_s_third ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   129.971k i/100ms
                original   123.802k i/100ms
    Calculating -------------------------------------
                    fast      1.273M (± 4.1%) i/s  (785.25 ns/i) -      6.369M in   5.011805s
                original      1.215M (± 1.8%) i/s  (823.04 ns/i) -      6.190M in   5.096330s

    Comparison:
                    fast:  1273487.0 i/s
                original:  1215002.9 i/s - same-ish: difference falls within error

    == left_s_length ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   211.093k i/100ms
                original   155.784k i/100ms
    Calculating -------------------------------------
                    fast      2.120M (± 1.9%) i/s  (471.63 ns/i) -     10.766M in   5.079336s
                original      1.565M (± 6.7%) i/s  (638.87 ns/i) -      7.789M in   5.007522s

    Comparison:
                    fast:  2120296.1 i/s
                original:  1565258.0 i/s - 1.35x  slower

    == right_s_length ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   213.977k i/100ms
                original   142.990k i/100ms
    Calculating -------------------------------------
                    fast      2.154M (± 1.3%) i/s  (464.15 ns/i) -     10.913M in   5.066124s
                original      1.446M (± 1.8%) i/s  (691.75 ns/i) -      7.292M in   5.046172s

    Comparison:
                    fast:  2154455.3 i/s
                original:  1445607.9 i/s - 1.49x  slower

    == both_s ==
    ruby 3.4.2 (2025-02-15 revision https://github.com/rubygems/rubygems/commit/d2930f8e7a) +PRISM [arm64-darwin23]
    Warming up --------------------------------------
                    fast   154.903k i/100ms
                original   131.011k i/100ms
    Calculating -------------------------------------
                    fast      1.515M (± 4.0%) i/s  (659.97 ns/i) -      7.590M in   5.019890s
                original      1.280M (± 5.3%) i/s  (781.28 ns/i) -      6.420M in   5.035387s

    Comparison:
                    fast:  1515223.3 i/s
                original:  1279957.8 i/s - 1.18x  slower
    ```

    https://github.com/rubygems/rubygems/commit/7195e77152

commit 2dc501497e4e49c20be87dfbd86337f9e0795ec7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-18 05:12:34 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-18 05:12:34 +0900

    [DOC] Fix indentation for documentation of Hash#compact

commit 52f6563422edd9b233dbe5f522058be230c63651
  Author:     Hiroaki Osawa <ikusawasi@gmail.com>
  AuthorDate: 2025-03-18 02:19:43 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-18 02:19:43 +0900

    Allow arguments to be passed through Binding#irb (#12796)

    * Allow arguments to be passed through Binding#irb

    Modified Binding#irb to forward any arguments to the underlying irb
    method call.

    * Update prelude.rb

    Co-authored-by: Stan Lo <stan001212@gmail.com>

    * Update prelude.rb

    Co-authored-by: Stan Lo <stan001212@gmail.com>

    ---------

    Co-authored-by: Stan Lo <stan001212@gmail.com>

  Notes:
    Merged-By: tompng <tomoyapenguin@gmail.com>

commit 1acfb29015dbc38fd345d8786aa78aad59f7dcd1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-17 21:37:00 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-17 23:55:11 +0900

    [Bug #21186] multibyte char literal should be a single letter word

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12946

commit c85dffeee2f1899e0db3bde6a4fb49bc90c90ec2
  Author:     Eileen M. Uchitelle <eileencodes@users.noreply.github.com>
  AuthorDate: 2025-03-17 23:42:48 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-17 23:42:48 +0900

    Avoid pinning `storage_head` in `iseq_mark_and_move` (#12880)

    * Avoid pinning `storage_head` in `iseq_mark_and_move`

    This refactor changes the behavior of `iseq_mark_and_move` to avoid
    pinning the `storage_head`. Previously pinning was required because they
    could be gc'd during `iseq_set_sequence` it would be possible to end
    up with a half build array of instructions. However, in order to
    implement a moving immix algorithm we can't pin these objects so this
    rafactoring changes the code to mark and move. To accomplish this, it was
    required to add `iseq_size`, `iseq_encoded`, and the `mark_bits` union
    to the `iseq_compile_data` struct. In addition `iseq_compile_data` sets
    a bool for whether there is a single or list of mark bits. While this
    change is needed for moving immix, it should be better for Ruby's GC
    as well.

    * Don't allocate mark_offset_bits for one word

    If only one word is needed, we don't need to allocate mark_offset_bits
    and can instead directly write to it.

    ---------

    Co-authored-by: Peter Zhu <peter@peterzhu.ca>

  Notes:
    Merged-By: eileencodes <eileencodes@gmail.com>

commit 8d6f153fba8ce48a8e31cb22a9c9222bbb1832f6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-13 13:37:01 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-17 23:42:16 +0900

    Manage skipping instance variable IDs in one place

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12923

commit 4c072c811905610a84107fdae103982d144b3d71
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-13 12:51:04 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-17 23:42:16 +0900

    Fix `assert_warning` for `Proc`

    `Proc` does not have `encoding` method.

    Also, make `assert_raise_with_message` accept a `Proc` as the expected
    pattern, as well.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12923

commit 8f19f0aad5f87d481b5ae4337afdb844bcce1885
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-17 19:13:47 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-17 19:18:49 +0900

    [ruby/optparse] Fix completion of key-value pairs array

    Enum array may be the list of pairs of key and value.  Check if only
    key is completable, not pair.

    Fix https://github.com/ruby/optparse/pull/93
    Fix https://github.com/ruby/optparse/pull/94

    https://github.com/ruby/optparse/commit/a8d0ba8dac

commit b5cdbadeeddd2b8e834b9d5565c13fcc43f3e684
  Author:     Jérôme Parent-Lévesque <jerome.parent-levesque@potloc.com>
  AuthorDate: 2025-03-16 04:05:50 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-17 16:26:23 +0900

    [Bug #21185] Fix Range#overlap? with infinite range
    Infinite ranges, i.e. unbounded ranges, should overlap with any other range
    which wasn't the case in the following example: (0..3).overlap?(nil..nil)

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12937

commit 3e04f7b69fb56eac88b56f491b6a298fcc28b7f9
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-03-17 05:00:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-17 05:00:08 +0900

    Only mark `cc->cme_` on valid imemo_callcache

    We observed T_NONE on `cc->cme_` on a --repeat-count=50 run a compaction
    test on CI:
    http://ci.rvm.jp/results/trunk-repeat50@ruby-sp2-noble-docker/5654900

    During reference updating for imemo_callcache in
    rb_imemo_mark_and_move(), if `cc->klass` is not live, but `cc->_cme` is
    live and moved, we go to the vm_cc_invalidate() path which
    leaves `cc->_cme` not updated and stale. In the next marking run after
    compaction, CME would've become a T_NONE.

    So to quote the comment above "... cc is invalidated by
    `vm_cc_invalidate()` and cc->cme is not be accessed."

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12936

    Merged-By: XrXr

commit 70a9e5f6eb42cb1badba13d118f3c0d4106a3fe1
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-15 06:54:08 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-17 00:35:32 +0900

    [DOC] Doc for Hash#transform_keys

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12935

commit 47d75b65bfde4d2803a415dea4fbbf2cffc66fe6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-14 16:21:59 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-16 17:33:58 +0900

    Make wrapper of `main` for wasm more generic

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12933

commit 453f88f7f1c339a5256bc3a2c733610cc3ee965c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-14 16:24:31 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-16 17:33:58 +0900

    Make ASAN default option string built-in libruby

    The content depends on ruby internal, not responsibility of the
    caller.  Revive `RUBY_GLOBAL_SETUP` macro to define the hook function.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12933

commit f23146f09f3c5d0d9b72d044efa0a544566b4a49
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-16 12:27:56 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-16 12:27:56 +0900

    Fix enums in comparisons

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12941

commit 06919949a60b42a8f30e8bd0cb075e17b05eebcd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-15 16:15:04 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-16 12:09:18 +0900

    [Bug #21141] [DOC] Clarify what time is in UTC

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12940

commit 35920f7a440139563e9e46686378bba062bd08c1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-15 15:52:49 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-15 16:02:19 +0900

    Refine `TestSocket_TCPSocket#test_initialize_failure`

    * Use `assert_raise_kind_of` instead of `rescue` and `flunk`.
    * Use `assert_include` for the pattern that may contain regexp meta
      characters.

commit 29c0ca58c22b25dbd323d1ba5cdcf6dbdfd505e5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-15 00:36:04 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-15 15:50:46 +0900

    Test for the crash

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12934

commit b148dfef5aa208cafa28626fd84c9762bfdfe0ac
  Author:     Luke Jahnke <luke.jahnke@gmail.com>
  AuthorDate: 2025-03-14 22:38:33 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-15 15:50:46 +0900

    Fix crash in TCPSocket.open

    Fix segfault crash observable with TCPSocket.open(nil, nil)

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12934

commit efb2d4363709b36a205791787f6812259027c6e1
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-14 23:41:27 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-14 23:41:27 +0900

    [DOC] Tweaks for Hash#to_h (#12918)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit de48e47ddf78aba02fd9623bc7ce685540a10743
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-13 21:29:37 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-14 17:51:57 +0900

    Invoke `inherited` callbacks before `const_added`

    [Misc #21143]

    Conceptually this makes sense and is more consistent with using
    the `Name = Class.new(Superclass)` alternative method.

    However the new class is still named before `inherited` is called.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12927

commit dd7deef338d843c8d866ddc279854068b39bfeb9
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-03-14 14:32:22 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-03-14 17:10:33 +0900

    Organize block_param_def by defining opt_block_param for non-terminal symbols

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12932

commit f5f195180883fe80f02bc2579ba9aa84118e834b
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-03-14 00:16:34 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-03-14 12:32:03 +0900

    Refactor parse.y to replace tIDENTIFIER and tCONSTANT with ident_or_const inline rules

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12929

commit a4328a424bbbe3fdeefa861d5946e6258bc87260
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-13 04:46:51 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-14 10:12:08 +0900

    [DOC] Tweaks for Hash#to_hash

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12920

commit 057ee25d1b5f0882615063c41d21083bd7c78415
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-13 04:37:38 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-14 10:11:47 +0900

    [DOC] Tweaks for Hash#to_proc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12919

commit ae7890df33577b9f4eecab5626644d619ba442dd
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-03-14 06:37:29 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2025-03-14 07:21:37 +0900

    Use the EC parameter in instructions.

    The forwarding instructions should use the `ec` parameter passed to
    vm_exec_core instead of trying to look up the EC via `GET_EC()`.  It's
    cheaper to get the local than to try looking up a global

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12931

commit 84f51eb02ac3b456e7b25d83e781202152abf21d
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-03-13 23:23:14 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-03-14 00:20:35 +0900

    Use user defined parameterizing rules `args_tail_basic`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12928

commit f2483c79fe651c3dc5f100348a22f6a34d1d34bd
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-13 22:54:15 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-13 23:24:48 +0900

    [ruby/prism] Use Set.new over to_set

    https://github.com/ruby/prism/commit/422d5c4c64

commit 31cf2684b0bc12cad19356672fcc86c6279b1f22
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-12 22:55:27 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-13 23:12:24 +0900

    Output object_id in object metadata for MMTk

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12915

commit bdb25959fb047af0358f33d7327b7752dca14aa4
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-12 22:25:51 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-13 23:12:24 +0900

    Move object_id to flags for ObjectSpace dumps

    Moving object_id dumping from ObjectSpace to the GC flags allows ObjectSpace
    to not assume the FL_SEEN_OBJ_ID flag and instead move it to the responsibility
    of the GC.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12915

commit 3d4c7c38020fa4de420e927e0b579aeff62b54ba
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-11 18:30:39 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-13 22:52:45 +0900

    [ruby/prism] Use `reverse_each` in the parser translator

    Avoids an array allocation which matters more and more
    the larger the file is.

    I have it at 14% of runtime.

    https://github.com/ruby/prism/commit/f65b90f27d

commit 67e6ccb23fd910b70b0d690adcb56395778c9f2a
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-11 17:05:21 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-13 22:52:45 +0900

    [ruby/prism] Optimize array inclusion checks in the parser translator

    I see `Array.include?` as 2.4% runtime. Probably because of `LPAREN_CONVERSION_TOKEN_TYPES` but
    the others will be faster as well.

    Also remove some inline array checks. They are specifically optimized in Ruby since 3.4, but for now prism is for >= 2.7

    https://github.com/ruby/prism/commit/ca9500a3fc

commit ee1f39ef882e7ce175794e6286c0dcafba0bfa35
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-03-13 20:45:23 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-03-13 22:08:01 +0900

    Add a document to autoload

    Users are responsible for avoiding circular autoload.

    [Misc #21154]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12926

commit 4b844f7d9e2f41cd6c0e9f1d30dcbf1a0f24b449
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-03-13 20:32:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-13 21:06:58 +0900

    [ruby/prism] Ensure backwards compatibility with the custom parser builder

    Temoprary backwards-compat code so that current users
    don't break.

    Eventually the Translation::Parser initializer should asser that the correct class is passed in.

    https://github.com/ruby/prism/commit/66b0162b35

commit 7c88cbb4a6c486348c44be24941f17ef8be6b329
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-01-10 02:01:59 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-03-13 18:43:48 +0900

    [Feature #20971] Deprecate `rb_path_check`

    https://bugs.ruby-lang.org/issues/20971

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12542

commit faa8ccb6850b9e16953f04d7cc49c11a3ded9008
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-03-13 16:01:36 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-13 16:01:36 +0900

    Update bundled gems list as of 2025-03-12

commit 482b5307f2efa1c6b2af5c3e8641b4ba59841127
  Author:     Yutaro Ohno <yutaro.ono.418@gmail.com>
  AuthorDate: 2025-03-12 15:48:56 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-13 13:43:36 +0900

    [DOC] Correct output in calling_methods.rdoc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12912

commit f9aadc62ed40d9b68e2ca64b1c0ee56f0c2b3322
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-13 10:45:36 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 13:08:15 +0900

    Use ghcr.io/ruby/fedora:latest instead of docker.io for avoiding rate limit

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12922

commit 069ecfe869f48c2bc3162de4ef00ac11d4a3e586
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-12 22:06:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 10:33:38 +0900

    [ruby/json] Release 2.10.2

    https://github.com/ruby/json/commit/350c1fd154

commit e6a2cf9fd79330bd6838cb504648a874f30f5629
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-12 02:49:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 10:33:25 +0900

    [ruby/json] Fix potential out of bound read in `json_string_unescape`.

    https://github.com/ruby/json/commit/cf242d89a0

commit 8cc85dc00feef7fc7846ad15df2778f58716c169
  Author:     Hartley McGuire <skipkayhil@gmail.com>
  AuthorDate: 2025-03-12 06:46:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-13 10:24:21 +0900

    [rubygems/rubygems] Remove array allocation from Candidate#<=>

    In a large application I profiled allocations while running `bundle
    update` and found that this method was ~60% of allocations while
    resolving (and Candidate#<=> is almost half of the total runtime).

    This commit removes the array allocation in Candidate#<=> (and similar
    methods since the implementations are so simple). The array is always
    the same two elements so they can just be compared directly.

    https://github.com/rubygems/rubygems/commit/6a7c411ba7

commit af76b7f4d9f791b8d20f567e0fa8a45488fa00b8
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-13 04:56:00 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-13 04:56:22 +0900

    [ruby/prism] Revert "Mark extension as Ractor-safe"

    https://github.com/ruby/prism/commit/56eaf53732

commit 242e99eb0f32e1705413d084126be4ae6525a804
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-03-13 02:16:38 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-13 04:15:03 +0900

    [ruby/prism] Mark extension as Ractor-safe

    https://github.com/ruby/prism/commit/10e5431b38

commit 08b3a45bc97c835b4677bf76dbce68fd51d81897
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-03-11 11:37:44 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-03-13 04:00:26 +0900

    Push a real iseq in rb_vm_push_frame_fname()

    Previously, vm_make_env_each() (used during proc
    creation and for the debug inspector C API) picked up the
    non-GC-allocated iseq that rb_vm_push_frame_fname() creates,
    which led to a SEGV when the GC tried to mark the non GC object.

    Put a real iseq imemo instead. Speed should be about the same since
    the old code also did a imemo allocation and a malloc allocation.

    Real iseq allows ironing out the special-casing of dummy frames in
    rb_execution_context_mark() and rb_execution_context_update(). A check
    is added to RubyVM::ISeq#eval, though, to stop attempts to run dummy
    iseqs.

    [Bug #21180]

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12898

commit 9b9661883b1e2cc85b1341d804b106885432d2bd
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-03-12 02:14:13 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-03-13 04:00:26 +0900

    Have `ast` live longer in ISeq.compile_file to fix GC stress crash

    Previously, live range of `ast_value` ended on the call right before
    rb_ast_dispose(), which led to premature collection and use-after-free.

    We observed this crashing on -O3, -DVM_CHECK_MODE, with GCC 11.4.0 on
    Ubuntu.

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12898

commit a8d63ecdb82c33744c0d1fcfa362b0c7247e83c9
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-13 00:24:11 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-13 02:27:03 +0900

    Fix flaky test_AREF_fstring_key

    The code between the two ObjectSpace.count_objects could trigger a GC,
    which could free string objects causing this test to fail.

    We can see this failure on CI http://ci.rvm.jp/results/trunk-random2@ruby-sp2-noble-docker/5651016

        TestHashOnly#test_AREF_fstring_key [test/ruby/test_hash.rb:1991]:
        <197483> expected but was
        <129689>.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12916

commit 9ec8dc9c6504e62c6a3ff6b111cee53f67d5508c
  Author:     Sarun Rattanasiri <midnight_w@gmx.tw>
  AuthorDate: 2025-03-08 23:43:11 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-13 01:03:47 +0900

    [ruby/openssl] mark `initialize_copy` as :nodoc:

    https://github.com/ruby/openssl/commit/17f87d2cf0

commit b8af9325c0f3440c5bec05605ec450ce6b0dacc5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-08-22 11:18:18 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-12 18:42:39 +0900

    [DOC] Discourage use of `USERDEF`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12914

commit 9459bedd84d479bb1d7d3d40bada1cecb4701c37
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-08-20 13:04:06 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-12 18:42:38 +0900

    [Bug #19841] Refine error on marshaling recursive USERDEF

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12914

commit 2782cc75a99751228bc55d6d0f04d3a1742087fa
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-12 14:55:04 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-12 18:20:40 +0900

    Win32: Remove intermediate files for rubyspec-capiext

commit 3239af9b5d5fb7c03a9c39c5469d79b199fe3bc8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-12 10:43:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-12 18:20:39 +0900

    Win32: Make object files in the same place as the DLLs

commit 1a222816fbe65e49f5f395dfd4a307763c00f012
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 17:00:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 18:02:09 +0900

    Restore to use rm_rf for failing example

    https://github.com/ruby/ruby/actions/runs/13804651931/job/38616664529?pr=12911

commit 1d07deb422819ce0be58c5d6dd24d632d30ef817
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-12 04:50:26 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 18:02:09 +0900

    [ruby/json] Raise a ParserError on all incomplete unicode escape sequence.

    This was the behavior until `2.10.0` unadvertently changed it.

    `"\u1"` would raise, but `"\u1zzz"` wouldn't.

    https://github.com/ruby/json/commit/7d0637b9e6

commit de9ce8c0e09c209d70394f32e0c51e5047b0607e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 12:01:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 18:02:09 +0900

    Use erb executable again

    Co-authored-by: David Rodríguez <deivid.rodriguez@riseup.net>

commit 63dbb2f8a231421e92480b8209c8f6323bbfbd23
  Author:     Jacob Atzen <jatzen@gmail.com>
  AuthorDate: 2025-03-10 18:54:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 18:02:09 +0900

    [rubygems/rubygems] Update docs for with/without consistency

    The with and without flags accepts both comma and space separated values.

    https://github.com/rubygems/rubygems/commit/b6149f61e3

commit 510edbccf92deff0ccc6b4a1e0686b180a432aff
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-05-29 20:19:37 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 18:02:09 +0900

    [rubygems/rubygems] Fix `ENAMETOOLONG` error when creating compact index cache

    If a custom rubygems source URI is long enough, Bundler may end up
    raising an `ENAMETOOLONG` error and crash.

    This commit fixes the problem by trimming the cache slug size to fit
    usual OS requirements.

    https://github.com/rubygems/rubygems/commit/df40ff1e14

    Co-authored-by: mbclu <mbclu@users.noreply.github.com>
    Co-authored-by: martinemde <martinemde@users.noreply.github.com>

commit 13020ac0696819f1e996c9a1998f782f624e5903
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-11 02:53:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 18:02:09 +0900

    [rubygems/rubygems] Path helper to build paths in compact index cache

    https://github.com/rubygems/rubygems/commit/d28f9b8515

commit 51958bae66df026823fff159dd7513daf74f5727
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-08 05:35:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 18:02:09 +0900

    [rubygems/rubygems] Prefer `FileUtils.rm_r` to `FileUtils.rm_rf` for specs

    Because it does not swallow errors if it fails to remove the given
    folders, making issues easier to debug.

    https://github.com/rubygems/rubygems/commit/0db12d7afc

commit f656d34f103d9cc53259239d164ffa86d4117f9c
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-08 04:47:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 18:02:09 +0900

    [rubygems/rubygems] Refactor specs to not try to remove folders that don't exist

    This has the following benefits:

    * Avoid duplicated work in some specs that first build a repo, and then
      overwrite it with a completely different set of gems.
    * Reduce RSpec nesting and improve readability.
    * The change also made surfaces several specs that were incorrect since
      they were unintentionally not testing the right thing.

    https://github.com/rubygems/rubygems/commit/ed430883e0

commit c68088038fb4555b821a5e60ab529843074014d1
  Author:     Naoto Ono <onoto1998@gmail.com>
  AuthorDate: 2025-03-12 11:34:03 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-12 11:34:03 +0900

    Launchable: Disable request retries when a timeout exception occurs (#12877)

    When a Launchable server is unstable, a ReadTimeoutException occurs in the Launchable CLI. In such case, the Launchable CLI retries requests, which slows down CI execution. In this PR, I configured the environment variable SKIP_TIMEOUT_RETRY to disable retry attempts on requests(Link: https://github.com/launchableinc/cli/pull/992).

    ```
    WARNING:urllib3.connectionpool:Retrying (Retry(total=2, connect=None, read=None, redirect=None, status=None)) after connection broken by 'ReadTimeoutError("HTTPSConnectionPool(host='api.mercury.launchableinc.com', port=443): Read timed out. (read timeout=15)")': /intake/organizations/ruby/workspaces/ruby/commits/collect/options
      WARNING:urllib3.connectionpool:Retrying (Retry(total=1, connect=None, read=None, redirect=None, status=None)) after connection broken by 'ReadTimeoutError("HTTPSConnectionPool(host='api.mercury.launchableinc.com', port=443): Read timed out. (read timeout=15)")': /intake/organizations/ruby/workspaces/ruby/commits/collect/options
      WARNING:urllib3.connectionpool:Retrying (Retry(total=0, connect=None, read=None, redirect=None, status=None)) after connection broken by 'ReadTimeoutError("HTTPSConnectionPool(host='api.mercury.launchableinc.com', port=443): Read timed out. (read timeout=15)")': /intake/organizations/ruby/workspaces/ruby/commits/collect/options
      HTTPSConnectionPool(host='api.mercury.launchableinc.com', port=443): Max retries exceeded with url: /intake/organizations/ruby/workspaces/ruby/commits/collect/options (Caused by ReadTimeoutError("HTTPSConnectionPool(host='api.mercury.launchableinc.com', port=443): Read timed out. (read timeout=15)"))
      Exception in thread "main" javax.net.ssl.SSLException: Connection reset
            at sun.security.ssl.Alert.createSSLException(Alert.java:127)
            at sun.security.ssl.TransportContext.fatal(TransportContext.java:331)
            at sun.security.ssl.TransportContext.fatal(TransportContext.java:274)
            at sun.security.ssl.TransportContext.fatal(TransportContext.java:269)
            at sun.security.ssl.SSLSocketImpl.handleException(SSLSocketImpl.java:1572)
            at sun.security.ssl.SSLSocketImpl.access$400(SSLSocketImpl.java:73)
            at sun.security.ssl.SSLSocketImpl$AppInputStream.read(SSLSocketImpl.java:982)
            at org.apache.http.impl.io.SessionInputBufferImpl.streamRead(SessionInputBufferImpl.java:137)
            at org.apache.http.impl.io.SessionInputBufferImpl.fillBuffer(SessionInputBufferImpl.java:153)
            at org.apache.http.impl.io.SessionInputBufferImpl.readLine(SessionInputBufferImpl.java:280)
            at org.apache.http.impl.conn.DefaultHttpResponseParser.parseHead(DefaultHttpResponseParser.java:138)
            at org.apache.http.impl.conn.DefaultHttpResponseParser.parseHead(DefaultHttpResponseParser.java:56)
            at org.apache.http.impl.io.AbstractMessageParser.parse(AbstractMessageParser.java:259)
            at org.apache.http.impl.DefaultBHttpClientConnection.receiveResponseHeader(DefaultBHttpClientConnection.java:163)
            at org.apache.http.impl.conn.CPoolProxy.receiveResponseHeader(CPoolProxy.java:157)
            at org.apache.http.protocol.HttpRequestExecutor.doReceiveResponse(HttpRequestExecutor.java:273)
            at org.apache.http.protocol.HttpRequestExecutor.execute(HttpRequestExecutor.java:125)
            at org.apache.http.impl.execchain.MainClientExec.execute(MainClientExec.java:272)
            at org.apache.http.impl.execchain.ProtocolExec.execute(ProtocolExec.java:186)
            at org.apache.http.impl.execchain.RetryExec.execute(RetryExec.java:89)
            at org.apache.http.impl.execchain.RedirectExec.execute(RedirectExec.java:110)
            at org.apache.http.impl.client.InternalHttpClient.doExecute(InternalHttpClient.java:185)
            at org.apache.http.impl.client.CloseableHttpClient.execute(CloseableHttpClient.java:83)
            at org.apache.http.impl.client.CloseableHttpClient.execute(CloseableHttpClient.java:108)
            at com.launchableinc.ingest.commits.CommitGraphCollector.transfer(CommitGraphCollector.java:131)
            at com.launchableinc.ingest.commits.CommitIngester.run(CommitIngester.java:145)
            at com.launchableinc.ingest.commits.CommitIngester.main(CommitIngester.java:72)
            Suppressed: java.net.SocketException: Broken pipe (Write failed)
                    at java.net.SocketOutputStream.socketWrite0(Native Method)
                    at java.net.SocketOutputStream.socketWrite(SocketOutputStream.java:111)
                    at java.net.SocketOutputStream.write(SocketOutputStream.java:155)
                    at sun.security.ssl.SSLSocketOutputRecord.encodeAlert(SSLSocketOutputRecord.java:81)
                    at sun.security.ssl.TransportContext.fatal(TransportContext.java:362)
                    ... 25 more
      Caused by: java.net.SocketException: Connection reset
            at java.net.SocketInputStream.read(SocketInputStream.java:210)
            at java.net.SocketInputStream.read(SocketInputStream.java:141)
            at sun.security.ssl.SSLSocketInputRecord.read(SSLSocketInputRecord.java:464)
            at sun.security.ssl.SSLSocketInputRecord.bytesInCompletePacket(SSLSocketInputRecord.java:68)
            at sun.security.ssl.SSLSocketImpl.readApplicationRecord(SSLSocketImpl.java:1350)
            at sun.security.ssl.SSLSocketImpl.access$300(SSLSocketImpl.java:73)
            at sun.security.ssl.SSLSocketImpl$AppInputStream.read(SSLSocketImpl.java:966)
            ... 20 more
      Couldn't get commit history from `/github/workspace/src`. Do you run command root of git-controlled directory? If not, please set a directory use by --source option.
      HTTPSConnectionPool(host='api.mercury.launchableinc.com', port=443): Read timed out. (read timeout=60)
      Command '['java', '-jar', '/root/.local/pipx/venvs/launchable/lib/python3.10/site-packages/launchable/jar/exe_deploy.jar', 'ingest:commit', '-endpoint',
    ```

    https://github.com/ruby/ruby/actions/runs/13572112090/job/37939529243

  Notes:
    Merged-By: ono-max <onoto1998@gmail.com>

commit 1ba93fdfd21f403889aa7930f7ef2ad4414aa00a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 09:59:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 11:05:39 +0900

    Update bundled_gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12910

commit 1cdec3240b3c998c0cbf73556786aa3fa0b02ae7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-12 04:05:05 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-12 10:55:03 +0900

    Fix memory leak in rb_reg_search_set_match

    https://github.com/ruby/ruby/pull/12801 changed regexp matches to reuse
    the backref, which causes memory to leak if the original registers of the
    match is not freed.

    For example, the following script leaks memory:

        10.times do
          1_000_000.times do
            "aaaaaaaaaaa".gsub(/a/, "")
          end

          puts `ps -o rss= -p #{$$}`
        end

    Before:

        774256
        1535152
        2297360
        3059280
        3821296
        4583552
        5160304
        5091456
        5114256
        4980192

    After:

        12480
        11440
        11696
        11632
        11632
        11760
        11824
        11824
        11824
        11888

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12905

commit 1b2cc9c2b80da4618499ab3dd3dd70a499546c75
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-12 10:54:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-12 10:54:49 +0900

    [DOC] Tweaks for Hash#slice

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12907

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 86eff8565b21ca7e8deff572feedbcd7d2421d55
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-12 07:26:57 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-12 10:54:06 +0900

    [DOC] Tweaks for Hash#to_a

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12908

commit 5208d2f440ec3175dc48ba5672413bb3b5cb4fd7
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-12 07:07:40 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-12 10:52:38 +0900

    [DOC] Tweaks for Hash#shift

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12906

commit 97231e4d7ece859ab7c7d81033e74d402176910e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-12 07:52:31 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-12 08:31:16 +0900

    Update bundled_gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12909

commit b52f78952039a6b50ceaee4626ef9f0fb59eab6b
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-12 04:19:38 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-12 04:19:38 +0900

    [DOC] Tweaks for Hash#select! (#12904)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit a5f29213dcd3bd3da896c34505d487569c9ad339
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-12 04:18:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-12 04:18:47 +0900

    [DOC] Tweaks for Hash#select (#12903)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 51e2ff1ef777f82b0898f30b636a29b92e63a2e1
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-12 04:18:06 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-12 04:18:06 +0900

    [DOC] Tweaks for Hash#reject!

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12902

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 3278e3b6f3b4252ab05988b000886e3b6f089404
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-11 11:57:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-12 00:46:05 +0900

    [Bug #21177] Win32: Allow longer path name

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12901

commit e51411ff1fa38b296020529b51241b96d2c15b54
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-11 04:47:57 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-12 00:44:07 +0900

    Fix flaky test_latest_gc_info_need_major_by

    The test could flake because a major GC could be triggered due to allocation
    for caches or other things, which would cause the test to fail.

commit 497f409ba402ee2207f71f6998fe996433370107
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-12 00:43:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-12 00:43:50 +0900

    [DOC] Tweaks for Hash#reject (#12876)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit e99026784a5af7b188eb8a98b708ed4b75922a6d
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-12 00:43:20 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-12 00:43:20 +0900

    [DOC] Tweaks for Hash#update

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12826

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 47c3ae6962900434b6ffd486decd639b76f3d54d
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-11 04:43:44 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-11 09:00:47 +0900

    Bump tolerance for weak reference test from 1 to 2

    The test fails sometimes with:

        TestGc#test_latest_gc_info_weak_references_count [test/ruby/test_gc.rb:421]:
        Expected 2 to be <= 1.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12894

commit ba5fb74583303d9e80f3700d0b5433cbc7e7c88e
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-11 05:18:59 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-11 06:57:44 +0900

    Fix `Socket.tcp_with_fast_fallback` to be usable from a Ractor

    [Bug #21179]

    ```
    socket.rb:1046:in 'Socket::HostnameResolutionStore#get_addrinfo': can not access non-shareable objects in constant
    Socket::HostnameResolutionStore::PRIORITY_ON_V6 by non-main ractor. (Ractor::IsolationError)
            from socket.rb:724:in 'block in Socket.tcp_with_fast_fallback'
            from socket.rb:720:in 'Socket.tcp_with_fast_fallback'
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12896

commit 6b4453e332d67b5fb8f6932244fff9c7b385abdc
  Author:     Koichi ITO <koic.ito@gmail.com>
  AuthorDate: 2025-02-26 13:02:17 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-11 01:57:46 +0900

    [ruby/prism] Support `itblock` for `Prism::Translation::Parser`

    ## Summary

    `itblock` node is added to support the `it` block parameter syntax introduced in Ruby 3.4.

    ```console
    $ ruby -Ilib -rprism -rprism/translation/parser34 -e 'buffer = Parser::Source::Buffer.new("path"); buffer.source = "proc { it }"; \
                                                          p Prism::Translation::Parser34.new.tokenize(buffer)[0]'
    s(:itblock,
      s(:send, nil, :proc), :it,
      s(:lvar, :it))
    ```

    This node design is similar to the `numblock` node, which was introduced for the numbered parameter syntax in Ruby 2.7.

    ```
    $ ruby -Ilib -rprism -rprism/translation/parser34 -e 'buffer = Parser::Source::Buffer.new("path"); buffer.source = "proc { _1 }"; \
                                                          p Prism::Translation::Parser34.new.tokenize(buffer)[0]'
    s(:numblock,
      s(:send, nil, :proc), 1,
      s(:lvar, :_1))
    ```

    The difference is that while numbered parameters can have multiple parameters, the `it` block parameter syntax allows only a single parameter.

    In Ruby 3.3, the conventional node prior to the `it` block parameter syntax is returned.

    ```console
    $ ruby -Ilib -rprism -rprism/translation/parser33 -e 'buffer = Parser::Source::Buffer.new("path"); buffer.source = "proc { it }"; \
                                                          p Prism::Translation::Parser33.new.tokenize(buffer)[0]'
    s(:block,
      s(:send, nil, :proc),
      s(:args),
      s(:send, nil, :it))
    ```

    ## Development Note

    The Parser gem does not yet support the `it` block parameter syntax. This is the first case where Prism's node design precedes that of the Parser gem.
    When implementing https://github.com/whitequark/parser/issues/962, this node design will need to be taken into consideration.

    https://github.com/ruby/prism/commit/c141e1420a

commit 13fa6cc6a328176334924a654c0e2d742b704ca9
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-04-26 19:32:29 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-10 20:01:03 +0900

    [ruby/optparse] [DOC] Extract description from README

    https://github.com/ruby/optparse/commit/83e8c23d68

commit 3cd3f766799eb1e591356acde3ab863e3bb3566a
  Author:     Kouhei Yanagita <yanagi@shakenbu.org>
  AuthorDate: 2025-01-09 11:00:54 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-10 19:21:29 +0900

    [ruby/optparse] Fix LESS environment variable setup in OptionParser#help_exit

    If the original value of LESS ends with an option starting with "--",
    simply appending "Fe" would result in an invalid option string.

    https://github.com/ruby/optparse/commit/30571f91d3

commit f4c16c57aad9138f236f4fa966893b21d5a64cbf
  Author:     Koichi ITO <koic.ito@gmail.com>
  AuthorDate: 2025-02-02 16:17:37 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-10 19:19:58 +0900

    [ruby/optparse] Make the result of `tty?` obtainable with flexible stdout

    In mock testing for stdout, `StringIO.new` is sometimes used to redirect the output.
    In such cases, the assignment is done with `$stdout = StringIO.new`, not the constant `STDOUT`.
    e.g., https://github.com/rubocop/rubocop/blob/v1.71.1/lib/rubocop/rspec/shared_contexts.rb#L154-L164

    After assigning `StringIO.new`, `$stdout.tty?` returns `false`,
    allowing the standard output destination to be switched during test execution.

    ```ruby
    STDOUT.tty?       # => true
    StringIO.new.tty? # => false
    ```

    However, since `STDOUT.tty?` returns `true`, a failure occurred in environments
    where the environment variables `RUBY_PAGER` or `PAGER` are set.
    e.g., https://github.com/rubocop/rubocop/pull/13784

    To address this, `STDOUT` has been updated to `$stdout` so that the result of `tty?` can be flexibly overridden.

    A potential concern is that `$stdout`, unlike `STDOUT`,
    does not always represent the standard output at the time the Ruby process started.
    However, no concrete examples of issues related to this have been identified.

    `STDOUT.tty?` is the logic of optparse introduced in https://github.com/ruby/optparse/pull/70.

    This PR replaces `STDOUT` with `$stdout` throughout, based on the assumption
    that `$stdout` is sufficient for use with optparse.

    https://github.com/ruby/optparse/commit/262cf6f9ac

commit 45e8dc1e85eced97c7e3b29c947757736a6fcf79
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-10 16:53:16 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-10 18:55:29 +0900

    [ruby/optparse] [DOC] Mention about post-check

    https://github.com/ruby/optparse/commit/e1957d7392

commit 9e265b583b5cc35b8120978c855e1a6a78abbe5b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-10 13:12:34 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-10 18:55:29 +0900

    [ruby/optparse] Add post-check of value

    Fix https://github.com/ruby/optparse/pull/80

    https://github.com/ruby/optparse/commit/050a87d029

commit b51450f3bd77f6dc862fcb8b177922a588f0e381
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-10 17:02:43 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-10 17:03:55 +0900

    [ruby/optparse] Update argument check with safe navigation operator

    https://github.com/ruby/optparse/commit/71e2b31824

commit 9de9cb53c091fa14397380fd0cc776330457ace6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-10 14:05:16 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-10 16:56:44 +0900

    [ruby/optparse] [DOC] Update documents to use single quotes instead of backqoutes

    https://github.com/ruby/optparse/commit/5e71a70cb5

commit 1a985d36a753e2e867c2a2c37548f514748d8c8e
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-07 03:45:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 12:43:36 +0900

    [rubygems/rubygems] Adapt specs to extraction of irb from ruby-core

    This gets our daily Bundler CI back to green.

    https://github.com/rubygems/rubygems/commit/1bb70f75d2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12890

commit 0ca5240d58e292d0b94a0476dbeee07f61bc08c9
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-07 03:45:21 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 12:43:36 +0900

    [rubygems/rubygems] `bundle console` deprecation was canceled

    https://github.com/rubygems/rubygems/commit/1c237a4c3f

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12890

commit 9d5a3c0314f8065ab8da54e82cfaebe5f538883a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-07 03:44:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 12:43:36 +0900

    [rubygems/rubygems] Reduce duplicate of some spec gemfiles

    https://github.com/rubygems/rubygems/commit/bd42c840c6

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12890

commit e21e5bc814484ea1f37c702404f434d72bd257c1
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-05 23:56:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 12:43:36 +0900

    [rubygems/rubygems] Fix `gem rdoc` not working with newer versions of rdoc

    https://github.com/rubygems/rubygems/commit/369f9b9311

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12890

commit 4323674fe4d697db48856292deb459f9ca923272
  Author:     Tara Bass <tara.bass@gusto.com>
  AuthorDate: 2025-02-28 04:44:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 12:43:36 +0900

    [rubygems/rubygems] Don't treat a git-sourced gem install as complete if only the '.git' directory is present. This recovers cases where a git-sourced install can be left in a partially installed state.

    https://github.com/rubygems/rubygems/commit/d132b7008d

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12890

commit 71e340881f1aca4911a35ddafd519fb0e29e6544
  Author:     Sean Collins <sean@cllns.com>
  AuthorDate: 2025-03-04 12:52:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 12:43:36 +0900

    [rubygems/rubygems] Switch inject to use shorthand hash syntax

    https://github.com/rubygems/rubygems/commit/ba5a62fd04

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12890

commit 8acf0d7bcc2a55299bed00caee9679446f04e0d0
  Author:     Sean Collins <sean@cllns.com>
  AuthorDate: 2025-03-04 07:12:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 12:43:36 +0900

    [rubygems/rubygems] Use shorthand hash syntax for bundle add

    https://github.com/rubygems/rubygems/commit/9691097036

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12890

commit afbc6649cd98226a1f221d87fc289dad2458a490
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-10 11:38:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 12:43:36 +0900

    Revert "Omit irb related examples temporary"

    This reverts commit 750e6195040ec3f9d0b172ac1a49a49d9b7d8ba0.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12890

commit ce4abf2a2b22b39d3653045e0b5351a27669ecbf
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-03-10 11:38:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-10 12:43:36 +0900

    Revert "Move irb detection to top-level before(:each) block"

    This reverts commit 261f8023842b6f90007df68dfc3d88a01a9337a2.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12890

commit cdf36d6bfd6409b8c626557aca7abf74b7e4e76c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-09 22:39:12 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-09 23:32:17 +0900

    [ruby/optparse] Allow non-string enum list #79

    Command line arguments are strings, convert enum list elements to
    strings to match.

    https://github.com/ruby/optparse/commit/c5ec052efc

commit 213c27825af45f25d27150a4d11164df04ee9080
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-09 22:54:21 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-09 23:32:17 +0900

    [ruby/optparse] Add test for enum arguments

    https://github.com/ruby/optparse/commit/0a0e977b7c

commit 0c73328affeeaf04684e15dbc8def018f30fa553
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-09 22:38:30 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-09 23:09:16 +0900

    [ruby/optparse] Use `\A` instead of `^` as the beginning of string

    https://github.com/ruby/optparse/commit/a3f1029815

commit 49199445f5be18cb2f97c5d0eaaa952329d0e09f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-09 21:56:59 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-03-09 23:03:55 +0900

    [ruby/optparse] [DOC] Manage rdoc options only in .rdoc_options file

    Make `rdoc .` and `rake rdoc` consistent.

    https://github.com/ruby/optparse/commit/61b4ea0704

commit 5965978efbfea95aefb6900dc9a594b682dae43b
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-03-09 02:06:54 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-03-09 11:26:56 +0900

    Merge the `new_yield` method into the `rb_node_yield_new` method

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12888

commit caa7eaecc5b0d2d97c56abe336270541a06702ed
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-03-09 01:39:36 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-03-09 02:56:26 +0900

    Refactor parser rules to remove inline_operation

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12886

commit 24945defa57ca2a12e5d2773552e9b156ad6ecf0
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2025-03-08 21:12:28 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-03-08 22:20:11 +0900

    Remove redundant semantic action in bvar rule

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12883

commit a14d9b8d5777b05e288b412bcdef609f05389fd7
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-08 05:38:30 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-08 18:56:02 +0900

    string.c: Improve `fstring_hash` to reduce collisions

    `rb_str_hash` doesn't include the encoding for ASCII only strings
    because ASCII only strings are equal regardless of their encoding.

    But in the case if the `fstring_table`, two identical ASCII strings
    with different encodings aren't equal.

    Given it's common to have both `:foo` (or `def foo`) and `"foo"`
    in the same source code, this causes a lot of collisions in the
    `fstring_table`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12881

commit eae0fe37c08b568c0a7cbf904caba4faca517746
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2024-11-03 23:52:50 +0900
  Commit:     Yudai Takada <t.yudai92@gmail.com>
  CommitDate: 2025-03-08 18:26:40 +0900

    Implement CLASS NODE locations

    The following Location information has been added This is the information required for parse.y to be a universal parser:

    ```
    ❯ ruby --parser=prism --dump=parsetree -e "class A < B; end"
    @ ProgramNode (location: (1,0)-(1,16))
    +-- locals: []
    +-- statements:
        @ StatementsNode (location: (1,0)-(1,16))
        +-- body: (length: 1)
            +-- @ ClassNode (location: (1,0)-(1,16))
                +-- locals: []
                +-- class_keyword_loc: (1,0)-(1,5) = "class"
                ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                +-- constant_path:
                |   @ ConstantReadNode (location: (1,6)-(1,7))
                |   +-- name: :A
                +-- inheritance_operator_loc: (1,8)-(1,9) = "<"
                ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                +-- superclass:
                |   @ ConstantReadNode (location: (1,10)-(1,11))
                |   +-- name: :B
                +-- body: nil
                +-- end_keyword_loc: (1,13)-(1,16) = "end"
                ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                +-- name: :A
    ```

commit 98790faae3cbbe67a5335df30f6e9000f3a83ad9
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-03-08 07:42:03 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-03-08 10:23:32 +0900

    YJIT: Add Counter::invalidate_everything

    When YJIT is forced to discard all the code, that's bad for
    performance, so there should be an easy way to know about it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12882

commit 3c92fe13f83c458991349a9b77963c90027fe53b
  Author:     kyontan <kyontan@monora.me>
  AuthorDate: 2025-03-08 06:18:25 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-08 06:18:25 +0900

    [DOC] Fix minor miscalculation of stack size

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12872

    Merged-By: XrXr

commit 17f6a689629ec3507a79fc156833f329dc641bed
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-07 23:38:51 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-07 23:38:51 +0900

    [DOC] Tweaks for Hash#rehash

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12875

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 8774530ce10bbee5b483b4e7283cc263b246125d
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-03-07 08:08:24 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-07 23:36:51 +0900

    [DOC] Tweaks for Hash#rassoc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12874

commit 42b75a9c6414eb93fdee777d87a7ad7562edf009
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-03-07 23:34:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-07 23:34:36 +0900

    [DOC] Tweaks for Hash#merge (#12825)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit f118e0ce734d7951597eddccff3695d6573589c4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-07 17:52:18 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-07 17:52:18 +0900

    [Bug #21174] [Bug #21175] Update rubyspec

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12879

commit cbe3156f82ee8b68e734be58badb9b6a3adc8aa6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-07 17:23:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-07 17:23:33 +0900

    [Bug #21174] [Bug #21175] Fix `Range#max` on beginless integer range

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12879

commit 8841f885bde7bbe571d2043830799059870dc70c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-04 10:22:17 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-03-07 12:14:48 +0900

    [Bug #21163] Fix hexadecimal float conversion

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12878

commit 6bad47ac6d62b54fe30e3f161c2a9d8f5fa4800c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-06 04:22:01 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-03-07 01:58:54 +0900

    RUBY_FREE_AT_EXIT does not work when error in -r

    [Bug #21173]

    When loading a file using the command line -r, it is processed before
    RUBY_FREE_AT_EXIT is checked. So if the loaded file raises an error, it
    will cause memory to not be freed with RUBY_FREE_AT_EXIT.

    For example `ruby -rtest.rb -e ""` will report a large amount of memory
    leaks if `test.rb` raises.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12859

commit bb91c303bad5fcdd59b73ca1a1923f71c7efdbfd
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-03-07 00:52:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-07 00:52:49 +0900

    YJIT: Rename get_temp_regs2() back to get_temp_regs() (#12866)

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit e20f1f76f4d7479faa112b612ba6f712a46c49fc
  Author:     Rahim Packir Saibo <i.am@rah.im>
  AuthorDate: 2025-03-06 03:03:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-06 18:29:27 +0900

    [ruby/json] Fix JSON::GeneratorError#detailed_message with Ruby < 3.2

    https://github.com/ruby/json/commit/2e015ff839

commit f7af75d3d9239dadd66382e421f63790ad46aeb7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-05 13:34:52 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-03-06 16:58:13 +0900

    Show test task names longer

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12871

commit ca4325f6c9710ae5dcda9f735b264ba92bffb68f
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-06 16:09:57 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-03-06 16:42:01 +0900

    Harden `TestObjSpace#test_memsize_of_root_shared_string`

    This test occasionally fail because it runs into a String instance
    that had its `==` method removed.

    I couldn't identify where this String comes from, but in general
    when using `each_object` it's best to not assume returned objectd
    are functional.

    By just inverting the operands of `==` we ensure it's always
    `String#==` that is called.

    ```
      1) Error:
    TestObjSpace#test_memsize_of_root_shared_string:
    NoMethodError: undefined method '==' for #<String:0x00007f9b50e8c978>
        /tmp/ruby/src/trunk-random1/test/objspace/test_objspace.rb:35:in 'block in TestObjSpace#test_memsize_of_root_shared_string'
        /tmp/ruby/src/trunk-random1/test/objspace/test_objspace.rb:35:in 'ObjectSpace.each_object'
        /tmp/ruby/src/trunk-random1/test/objspace/test_objspace.rb:35:in 'TestObjSpace#test_memsize_of_root_shared_string'
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12870

commit c939d0c85d1da76477a268058689f2f65e02d4be
  Author:     Naoto Ono <onoto1998@gmail.com>
  AuthorDate: 2025-03-06 12:39:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-06 12:39:39 +0900

    Launchable: Send stdout and stderr (#12785)

    Currently, the Launchable team is developing a new feature to attach any logs. Attached log can be anything, such as system logs or stdout. Users can find these logs using any text search. Please note that this feature is a work in progress, so we can't use it yet.

    I'm going to attach stdout and stderr as attached logs because they will be useful for finding interpreter bugs. When running tests, we sometimes see interpreter itself crash, and the stack is output to stderr. When debugging the cause of the issue, this feature is useful.

  Notes:
    Merged-By: ono-max <onoto1998@gmail.com>

commit 309076ff91601f718f8e1285060c486c6bf37c67
  Author:     Naoto Ono <onoto1998@gmail.com>
  AuthorDate: 2025-03-06 12:18:54 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-03-06 12:18:54 +0900

    Fix flaky failure in TestSetTraceFunc#test_tracepoint_disable (#12854)

    TestSetTraceFunc#test_tracepoint_disable is a flaky and failing intermittently. Here is an example of failure logs.

    ```
       1) Failure:
      TestSetTraceFunc#test_tracepoint_disable [/home/runner/work/ruby/ruby/src/test/ruby/test_settracefunc.rb:857]:
      <[:foo, :disable, :foo, :disable]> expected but was
      <[:call, :call, :foo, :disable, :foo, :disable]>.
    ```
    https://github.com/ruby/ruby/actions/runs/13619175633/job/38066208546?pr=12585#step:12:875

    I printed values of TracePoint objects as follows, and checked the values when failing intermittently.

    https://github.com/ruby/ruby/blob/7f9a6fc582fb5cfd88ab73a61782f39894a37ba6/test/ruby/test_settracefunc.rb#L848

    Here is the log when the TestSetTraceFunc#test_tracepoint_disable failed intermittently.

    `2025-03-05T09:08:37.4075411Z e: call, f: /home/runner/work/ruby/ruby/src/lib/tempfile.rb, l: 386, i: call, d: Tempfile::FinalizerManager` is an unexpected events. Thus, I modified test code so that we can filter out unexpected trace events.

    ```
    2025-03-05T09:08:37.4075411Z e: call, f: /home/runner/work/ruby/ruby/src/lib/tempfile.rb, l: 386, i: call, d: Tempfile::FinalizerManager
    2025-03-05T09:08:37.4085009Z e: call, f: /home/runner/work/ruby/ruby/src/test/ruby/test_settracefunc.rb, l: 808, i: foo, d: TestSetTraceFunc
    2025-03-05T09:08:37.4086042Z e: call, f: <internal:trace_point>, l: 295, i: disable, d: TracePoint
    2025-03-05T09:08:37.4115693Z e: call, f: /home/runner/work/ruby/ruby/src/test/ruby/test_settracefunc.rb, l: 808, i: foo, d: TestSetTraceFunc
    2025-03-05T09:08:37.4116734Z e: call, f: <internal:trace_point>, l: 295, i: disable, d: TracePoint
    ```

  Notes:
    Merged-By: ono-max <onoto1998@gmail.com>

commit e8f8565dc2afc586ed9eae1b75623f7aca9b7df7
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-03-06 09:23:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-06 09:23:31 +0900

    Remove obsoleted insn_may_depend_on_sp_or_pc()

    which was for MJIT

commit 0d03183748e29a7133df3e9bde99f5d9258ce6f1
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-03-06 08:46:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-06 08:46:51 +0900

    auto-request-review should run only for master

    Backport PRs are reviewed only by the branch maintainers.

commit 443e2ec27db89c896bd62994f6e04d8d6d48cddb
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-05 05:54:33 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-03-06 07:05:24 +0900

    Replace tombstone when converting AR to ST hash

    [Bug #21170]

    st_table reserves -1 as a special hash value to indicate that an entry
    has been deleted. So that that's a valid value to be returned from the
